/*
   *** Requires /js/ajax/ajaximpl.js, jQuery and jQuery UI (Dialog).

   Customized AJAX routines for the mapper.  Works inside Iguana, using the
   mini-login for errors, and outside of Iguana using a simpler interface.
*/

var Ajax;
$(document).ready(function() {
   var m_OnRetry;
   var m_Ready;

   function createPopup() {
      $('body').append('\
         <div id="ajax-popup" style="display:none">\
            <table width="100%">\
            <tr>\
               <td colspan="2" id="ajax-message" align="center">\
            </table>\
         </div>\
      ');
      return $('#ajax-popup').dialog({
         'autoOpen': false,
         'modal': true,
         'title': 'Communication Error',
         'buttons': {
            'Retry': function() {
               $(this).dialog('close');
               var Retry = m_OnRetry;
               m_OnRetry = null;
               Retry();
            }
         }
      });
   }

   function why(Status, Request) {
      if(Request.status == 403)  // 403 Forbidden
         return 'Your session has expired.';
      else if(Status == 'parsererror')
         return 'Got unexpected response from server.';
      else if(Status == 'edit_session_expired')
         return 'Your editor session has expired.';
      else if(Status != 'notmodified')
         return 'The server is not responding.';
   }

   function onAjaxError(Status, OnRetry, Request) {
      if(!m_Ready)
         return;
      if(m_OnRetry) {
         var OldOnRetry = m_OnRetry;
         m_OnRetry = function() {
            try { OldOnRetry(); }
            catch(Error) { }
            OnRetry();
         };
      } else {
         var Popup = $('#ajax-popup');
         if(!Popup.length) Popup = createPopup();
         m_OnRetry = function() { OnRetry(); };
         $('#ajax-message').text(why(Status, Request));
         Popup.dialog('open');
      }
   }

   function onAjaxSuccess(Response, Status, Request) {
      if(Response.SessionExpired)
         return 'edit_session_expired';
   }

   // If we are in Iguana, we want to use the mini-login for AJAX.
   if(!window.MiniLogin) {
      Ajax = AjaxImpl(onAjaxError, onAjaxSuccess);
   } else {
      Ajax = AjaxImpl(function(Status, RetryThunk, Request) {
         MiniLogin.show(why(Status, Request), function() { location.reload(); });
      }, onAjaxSuccess);
   }

   // We had some trouble with the mini-login popping up when switching
   // between pages.  Originally we used to delay five seconds before
   // displaying the login, but this might be a better solution if we
   // get the unload event before any AJAX requests fail.
   $(window).unload(function() { m_Ready = false; });
   m_Ready = true;
});
