function NISclearAnnotationBlockData(Editor){
 var CleanedBlockDataSet = {};
 var NumberOfBlocks = Editor.ifware.BlockDataSet.length;
 var j = 0;
 for(var i = 0; i < NumberOfBlocks; ++i){
  var BlockData = Editor.ifware.BlockDataSet[i];    
  if("annotation" != Editor.ifware.BlockDataSet[i].type){
   CleanedBlockDataSet[j] = BlockData;
   ++j;
  }
 }
 Editor.ifware.BlockDataSet = CleanedBlockDataSet;
 Editor.ifware.BlockDataSet.length = j; 
}

function NISretrieveAnnotationBlockData(Editor, BlockDataSet){
 NISclearAnnotationBlockData(Editor);

 var NumberOfAnnotations = BlockDataSet.length;
 var NumberOfCodeLines = Editor.ifware.BlockDataSet.length;
 for(var i = NumberOfCodeLines, j = 0; j < NumberOfAnnotations; ++i, ++j){
  Editor.ifware.BlockDataSet[i] = BlockDataSet[j];    
  Editor.ifware.BlockDataSet[i].type = "annotation";
  ++(Editor.ifware.BlockDataSet.length);
 }
 
 // Unfortunately I have to keep two copies since some functions expect you to pass 
 // only the annotation blocks while others want all block types.
 Editor.ifware.AnnotationBlockDataSet = BlockDataSet;
}

function NISprocessAnnotation2(Response, TextStatus, RequestObject, Editor){
 Editor.ifware.AnnotationsStatusContainer.innerHTML = '';
 if (Response.ErrorMessage){
  Editor.ifware.AnnotationsStatusContainer.innerHTML = Response.ErrorMessage;
  return;
 }
 Editor.ifware.AnnotationsStatusContainer.innerHTML = '<span class="ok">Got data</span>';
 console.log(Response);
 if (Response.Code){
  console.log("Got Code!");
  NISsetCode(Editor, Response.Code);
 }

 NISretrieveCodeBlockData(Editor);
 NISretrieveMergeConflictData(Editor);

 if (Response.BlockData){
  NISlogWithTime('Got anotation data.');
  NISrefreshBlockInfo2(Editor, Response.BlockData);
  NISlogWithTime('Refreshed blocks.');
  NISretrieveAnnotationBlockData(Editor, Response.BlockData);
 }

 ETHscrollerControl.setStylizer(function(Type){ return NISretrieveBlockStyle(Type); });
 ETHscrollerControl.setMaxLineLengthCalculator(function(BlockDataSet, CharWidth){ return NISmaxCodeOfLineLength(BlockDataSet, CharWidth); });
 ETHscrollerControl.setOptimalBlockWidthCalculator(function(BlockData, MaxLineLength, ThumbnailContainerWidth, CharWidth){ return NISoptimalBlockWidth(BlockData, MaxLineLength, ThumbnailContainerWidth, CharWidth); });

 ETHscrollerControl.show(Editor); 

 if (Response.ScriptError){
  NISdisplayScriptError(Editor, Response.ScriptError);
 }
 PRJrefreshProjectManager(Response.file_info, Editor);
}

function NISclearAllBlocks(Editor){
 var Blocks = Editor.ifware.BlockInfo;
 for (i in Blocks){
  $(Editor.frame.contentDocument).contents().find("#n" +i).remove();
 } 
}

function NISrefreshBlockInfo2(Editor, BlockUpdate){
 var NewBlockTable = {};
 var i;
 Blocks = Editor.ifware.BlockInfo;
 if (NISeditorIsEmpty(Editor) || !BlockUpdate){
    NISclearAnnotations(Editor);
    return;
 }
 var CharWidth = Editor.ifware.CharWidth;
 var Lines = NISgetLines(NISgetEditorDiv(Editor));
 NISlogWithTime('Got lines and char width');   
 for (i = 0; i < BlockUpdate.length; i++){ 
    NewBlockTable[BlockUpdate[i].s] = i; 
 }
 NISlogWithTime('Set up new block table');   
 for (i in Blocks){
  if (typeof NewBlockTable[i] == "undefined"){
    delete Blocks[i];
    //console.log("Block deleted:", i );
    $(Editor.frame.contentDocument).contents().find("#n" +i).remove();
  } 
 }
 NISlogWithTime('Removed blocks that no longer exist.');   
 for (i in NewBlockTable){
  if (typeof Blocks[i] == "undefined"){
   Blocks[i] = {"pos":0,"count":BlockUpdate[NewBlockTable[i]].l};
   //console.log("Block created:", i);
  } else {
   $(Editor.frame.contentDocument).contents().find("#n" +i).remove(); // removing for now since our creation logic is dumb
   Blocks[i].count = BlockUpdate[NewBlockTable[i]].l; // call count
   Blocks[i].pos = 0;
   //if (Blocks[i].pos > Blocks[i].count) Blocks[i].pos = Math.max(Blocks[i].count-1, 0);
   //console.log("Block exists:", i); 
  }
  //NISlogWithTime('NIScreateAnnotationBlock2 ' + BlockUpdate[NewBlockTable[i]].s);   
  NIScreateBlock(Editor, Lines, CharWidth, BlockUpdate[NewBlockTable[i]], Blocks[i].pos);
  //NISlogWithTime('Done NIScreateAnnotationBlock2');
 } 
}

// NOTE - used in old annotations so don't change it until we are ready to remove them.
function NISsetButtonVisibility(Elements,Hidden){
 Images = Elements.find("img");
 Images.each(function(){
  var FileName = $(this).attr("src");
  var StartIndex = (FileName.indexOf('/') >= 0) ? FileName.lastIndexOf('/') : 0;
  var DesiredPrefix = Hidden ? "dis" : "ena";
  if (FileName.substr(DesiredPrefix.length, 3) != DesiredPrefix) {
   var NewFileName = FileName.substr(0, StartIndex + 1) + DesiredPrefix + FileName.slice(StartIndex + DesiredPrefix.length + 1, FileName.length);
   $(this).attr("src", NewFileName);
  }
 });
}

function NIScontrolBlock2(Block){
   return "<div class='annav'><span class='nv ncback'><img class='bb' src='/js/mapper/images/ena_l_stop_arrow.png'/><img class='b' src='/js/mapper/images/ena_l_arrow.png'/></span><span class='inner'><span style='white-space: pre' class='position'>" + Block.p + "</span> of " + Block.l + "</span><span class='nv ncforw'><img class='f' src='/js/mapper/images/ena_r_arrow.png'/><img class='ff' src='/js/mapper/images/ena_r_stop_arrow.png'/></span></span></div>";
}

function NIShideNavControl(Ann){
 var ElementsToHide = $(Ann).find('.nv');
 if ($.browser.msie)
  ElementsToHide.css("visibility", "hidden").end()
 else
  ElementsToHide.stop(true, true).fadeTo("fast", 0);
}

function NISshowNavControl(Ann){
 var ElementsToShow = $(Ann).find('.nv');
 if ($.browser.msie)
  ElementsToShow.css("visibility", "").end()
 else
  ElementsToShow.stop(true, true).fadeTo("fast", 1);
}

function NISupdateNav(Nav, Block, Editor){
 console.log(Block);
 $(Nav).find('span.position').html(Block.p);
 NISsetButtonVisibility($(Nav).find("span.ncback"), Block.p == 1);
 NISsetButtonVisibility($(Nav).find("span.ncforw"), Block.p == Block.l);
 var Vars = {};
 Vars.ChannelGuid = Editor.ifware.ChannelGuid;
 Vars.TargetCall = Block.p;
 Vars.FunctionLine = Block.s;
 Ajax.post('/annotation_get_block', Vars, function(R){NISupdateAnnBlock(R,Nav,Block, Editor); }, 'json');
}

function NISupdateAnnBlock(Response, Nav,Block, Editor){
 console.log(Response);
 if (Response.ErrorMessage) {
  $(Nav).parent().find('span.content').html(Response.ErrorMessage);
  return;
 }
 $(Nav).parent().find('span.content').html(Response.d)
  .find("span.lt").click(function(){ NISlongStringDialog(Editor, this); }).end()
  .find("a.ntv").click(function(Event){ NIStreeviewDialog(Event, Editor, this); });
} 

function NISattachNavClick(Nav, Block, Editor){
 $(Nav)
  .find("span.inner").click(function(){ NISinsertGotoIframe2($(this), Nav, Block, Editor, Block.s); }).end()
  .find("img.bb").click(function(){ Block.p = 1;                            NISupdateNav(Nav, Block, Editor); }).end()
  .find("img.b") .click(function(){ Block.p = Math.max(1, Block.p-1);       NISupdateNav(Nav, Block, Editor); }).end()
  .find("img.f") .click(function(){ Block.p = Math.min(Block.l, Block.p+1); NISupdateNav(Nav, Block, Editor); }).end()
  .find("img.ff").click(function(){ Block.p = Block.l;                      NISupdateNav(Nav, Block, Editor); }).end();
} 

function NIScreateBlock(Editor, Lines, CharWidth, BlockData, Selected){
 var Ann = document.createElement('div');
 $(Ann).attr('id', 'n' + BlockData.s);
 Ann.className = 'ANNblock';
 Ann.style.position = 'absolute';
 $(Ann).css('top', Lines[BlockData.s] + NISinternetExplorerOffset() + 'px');
 Ann.style.left = CharWidth * (BlockData.c + 2) + "px";
 if (BlockData.l > 1){
    $(Ann).html('<span class="content">' + BlockData.d + '</span>' + NIScontrolBlock2(BlockData))
          .children().andSelf().hover(function(){ NISshowNavControl(this); }, function() { NIShideNavControl(this); });
    //console.log(BlockData);
    NISsetButtonVisibility($(Ann).find("span.ncback"), BlockData.p == 1);
    NISsetButtonVisibility($(Ann).find("span.ncforw"), BlockData.p == BlockData.l);
    $(Ann).find('.nv').fadeTo(0, 0);
    NISattachNavClick($(Ann).find('div.annav'), BlockData, Editor);
 }else{
    $(Ann).html(BlockData.d);
 }
 NISgetEditorBody(Editor).appendChild(Ann);
 $(Ann).find("span.lt").click(function(){ NISlongStringDialog(Editor, this); }); 
 $(Ann).find("a.ntv").click(function(Event){ NIStreeviewDialog(Event, Editor, this); });
 BlockData.w = $(Ann).outerWidth();
}

function NISlongStringDialog(Editor, Element){
 console.log(Element);
 var Vars={};
 Vars.ChannelGuid = Editor.ifware.ChannelGuid;
 Vars.Id = Element.id;
 $(Element).addClass('waiting');
 Ajax.post('/annotation_full_arg', Vars, function(R,T,RO){ NISshowLongStringDialog(R,T,RO,Element); }, 'json');
}

function NISsavePopupGeometry(WidthAdjustment, HeightAdjustment){
 var Popup = $(this).parent();
 var PopupOffset = Popup.offset();
 COOKIEcreate('ANNpopupTop',    PopupOffset.top,  30);
 COOKIEcreate('ANNpopupLeft',   PopupOffset.left, 30);
 COOKIEcreate('ANNpopupWidth',  Popup.outerWidth()  - WidthAdjustment,  30);
 COOKIEcreate('ANNpopupHeight', Popup.outerHeight() - HeightAdjustment, 30);
}

function NISonPopupClose(){
 $(this).parent().remove();
 $(this).remove();
}

function NISinitDialog(Popup, Body){
 var DialogOptions = {
  close: NISonPopupClose,
  width: Body.outerWidth()/2,
  height: Body.outerHeight()/2
 };
 
 if ($('div.ANNpopup').size() == 1){
  // If this is the only popup we're showing, we'll use restored
  // geometry from the last touched popup.
  var PopupTop    = COOKIEread('ANNpopupTop');
  var PopupLeft   = COOKIEread('ANNpopupLeft');
  var PopupWidth  = COOKIEread('ANNpopupWidth');
  var PopupHeight = COOKIEread('ANNpopupHeight');
  if (PopupTop && PopupLeft) DialogOptions.position = [parseInt(PopupLeft), parseInt(PopupTop)];
  if (PopupWidth)  DialogOptions.width  = parseInt(PopupWidth);
  if (PopupHeight) DialogOptions.height = parseInt(PopupHeight);
 }
 
 Popup.dialog(DialogOptions);
 EDTiframeDialogFix(Popup);
 
 // Find the difference between our specified dimensions and the actual dimensions.
 // We'll need these in order to save the geometry.
 var WidthAdjustment  = Popup.parent().outerWidth()  - DialogOptions.width;
 var HeightAdjustment = Popup.parent().outerHeight() - DialogOptions.height;
 Popup.bind('dialogbeforeclose', function(){
  NISsavePopupGeometry.call(Popup, WidthAdjustment, HeightAdjustment);
 });
}

function NISshowLongStringDialog(Response, Status, RequestObject, Element){
 $(Element).removeClass('waiting');
 
 var Body = $('body');
 var Popup = $('<div class="ANNpopup"></div>').appendTo(Body);
 Popup.attr('title', 'Drag to move');
 if (Response.ErrorMessage) {
  Popup.html(Response.ErrorMessage);
 }
 else {
  Popup.html(Response.string);
 }
 
 NISinitDialog(Popup, Body);
}

function NIStreeviewDialog(Event, Editor, Element){
 Event.preventDefault();
 var Vars={};
 Vars.ChannelGuid = Editor.ifware.ChannelGuid;
 Vars.Id = Element.id;
 $(Element).addClass('waiting');
 Ajax.post('/annotation_full_arg', Vars, function(R,T,RO){ NISshowTreeviewDialog(R,T,RO,Element); }, 'json');
}

function NISshowTreeviewDialog(Response, Status, RequestObject, Element){
 $(Element).removeClass('waiting');

 var Body = $('body');
 var Popup = $('<div class="ANNpopup"></div>').appendTo(Body);
 Popup.attr('title', 'Drag to move');
 if (Response.ErrorMessage) {
  Popup.html(Response.ErrorMessage);
 }
 else {
  var Treeview = $('<ul class="ifwareTreeview"></ul>').appendTo(Popup);
  NTRinitTreeview(Response.Root, Treeview.get(0));
 }
 
 NISinitDialog(Popup, Body);
}

function NISlineLength(Editor, LineNumber){
 var EditorLine = Editor.nthLine(LineNumber);
 return Editor.lineContent(EditorLine).length;
}

// Mark the "current" annotation as stale (making it transparent).
// The "current" annotation is determined by the top of the current line.
//
function NISmarkAnnotationAsStale(Editor, LineNumber, LineTop){
 var AnnotationDivs = $(NISgetEditorBody(Editor)).find('div.ANNblock').toArray();
 for (var i = AnnotationDivs.length-1; i>= 0; i--){
  var AnnotationDiv = $(AnnotationDivs[i]);
  var AnnotationDivPos = AnnotationDiv.offset();
  var MyTop = AnnotationDivPos.top;
  var MyBottom = MyTop + AnnotationDiv.outerHeight();
  if (LineTop >= MyTop && LineTop < MyBottom){
   var CharWidth = Editor.ifware.CharWidth;
   var LineLength = NISlineLength(Editor, LineNumber);
   var LineWidth = CharWidth*(LineLength + 2);
   // A stale annotation block will be displayed with at most 0.85 opacity.
   // As the cursor gets closer, opacity decreases, to a minimum of 0.15.
   var Opacity = 0.85 - Math.max(0.15,
    0.7 * (LineWidth/Math.max(1, AnnotationDivPos.left, LineWidth)) );
   AnnotationDiv.fadeTo(125, Opacity);
   break;
  }
 }
}

function NISerrorText(Err){
 if (Err.FileName != ''){
  return 'Error in ' + Err.FileName + ' on line ' + Err.LineNumber;
 } else {
  return 'Error ' + ' on line ' + Err.LineNumber;
 }
}

function NISdisplayScriptError(Editor, ScriptError){
   var TopOffset = 0;
   var CharWidth = Editor.ifware.CharWidth;
   var Lines = NISgetLines(NISgetEditorDiv(Editor));
   console.log("Script error:", ScriptError);
   if (!ScriptError.LineNumber){
    // TODO - in an ideal world, we will always have a line number.
    ScriptError.LineNumber = 1;
   }
   var StatusBar = $(Editor.ifware.AnnotationsStatusContainer);
   StatusBar.empty();
   $('<a href="" class="el">' + NISerrorText(ScriptError) + '</a>').appendTo(StatusBar).click(function(Event){
    Event.preventDefault();
    var WindowHeight = 0;
    if (!window.innerHeight){
      WindowHeight = Editor.win.document.documentElement.clientHeight;
    } else {
      WindowHeight = Editor.win.innerHeight;
    }
    Editor.win.scroll(0, LineTop-(WindowHeight/2))
   });
      
   if (Editor.ifware.LuaFileName !== '' && Editor.ifware.LuaFileName !== ScriptError.FileName && ScriptError.FileName !== ''){
      return;
   }
   var LineTop = Lines[ScriptError.LineNumber];
   var LineLength = NISlineLength(Editor, ScriptError.LineNumber);
   var Body = NISgetEditorBody(Editor);

   var ErrorRow = document.createElement("div");
   ErrorRow.className = 'error-highlight-row';
   ErrorRow.style.top = LineTop + NISinternetExplorerOffset() + 'px';

   var ErrorBox = document.createElement("div");
   ErrorBox.className = 'error-box';
   ErrorBox.style.top = (LineTop - 2) + NISinternetExplorerOffset() + 'px';
   ErrorBox.style.left = CharWidth * (LineLength + 2) + 'px';
   
   var CloseButton = document.createElement("img");
   CloseButton.className = 'error-close';
   CloseButton.src = '/js/mapper/images/close_button_red.gif';
   CloseButton.onclick = function (){
      $(ErrorBox).fadeOut('fast', function() {NISclearErrorBox(Editor);} );
      $("rect.lua-error").remove();
   }
   ErrorBox.appendChild(CloseButton);
   ErrorBox.appendChild(document.createTextNode(ScriptError.Description));

   Body.appendChild(ErrorRow);
   Body.appendChild(ErrorBox);
   
   ETHscrollerControl.showError(ScriptError, LineLength);
}

function NISinsertGotoIframe2(Parent, Nav, BlockInfo, Editor, BlockStart){
 var Position = Parent.find(".position").get(0);
 var SavedValue = Position.innerHTML;
 var Width = Parent.parent().width()+6;
 var Height = Parent.parent().height();
 var FrameName = 'iframe' + BlockStart;
 var IframeDoc;
 var ExistingFrame = $(Editor.frame.contentDocument).find('#' + BlockStart).find("iframe");
 var Iframe;

 if (ExistingFrame.length === 0) {
  Iframe = NIScreateIframe(FrameName, Width, Height, Parent.get(0).parentNode);
 }else {
  Iframe = ExistingFrame.get(0);
 }
 if (Iframe) {
  if (Iframe.contentDocument) {
   IframeDoc = Iframe.contentDocument;
  } else if (Iframe.contentWindow) {
   IframeDoc = Iframe.contentWindow.document;
  } else if (window.frames[iframe.name]) {
   IframeDoc = window.frames[Iframe.name].document;
  }
  if (IframeDoc) {
   IframeDoc.open();
   IframeDoc.write('<html><body style="overflow: hidden; border: 1px solid #cccccc; -moz-border-radius:0 0 5px 5px; -webkit-border-radius:0 0 5px 5px; background: transparent url(/js/mapper/images/toolbar/bg_button_span.gif) no-repeat -5px -1px; font: normal 9px Lucida Sans, sans-serif; margin: 0px; padding: 0px;"><span style="padding: 0px 3px 0px 6px;">Go to </span><input id="input_field" style="width:20px; font-size: 9px; padding:1px 0px 0px 0px; margin:1px 5px 0px 0px; border:1px solid #CCCCCC;" type="text" value="' + SavedValue + '" /><img src="/js/mapper/images/ok.png" style="position:absolute;"/><\/body><\/html>');
   IframeDoc.close();
  }
  var InputField = $(IframeDoc).find("#input_field");
  $(Iframe).show();
  InputField.focus();
  InputField.select();

  var ChangeHandler = function() {
   var NewPos = parseInt(InputField.get(0).value, 10);
   if (!isNaN(NewPos)) {
    if (NewPos < 0) NewPos = 1;
    if (NewPos > BlockInfo.l) NewPos = BlockInfo.l;
    BlockInfo.p = NewPos;
    NISupdateNav(Nav, BlockInfo, Editor);
   }
   // Clear the frame by overwriting contents. Cannot use $().hide() since
   // chrome does not like it.
   IframeDoc.open();
   IframeDoc.write('<html><\/html>');
   IframeDoc.close();
  };
  InputField.blur(ChangeHandler);
  InputField.keydown(function(event) {
  if (event.keyCode == '13') {
   ChangeHandler();
  } else if (event.keyCode == '27') {
   iframeDoc.open();
   iframeDoc.write('<html><\/html>');
   iframeDoc.close();
  }
 });      
}
}

