function BTRview(Params){
 if (!Params.Chunk && !Params.Index) Params.Chunk = 0;
 Ajax.post('/bulk_testing_results', Params, function(Response){ BTRrenderResultsView(Response, Params); }, 'json');
}

function BTRresultRow(Result, TotalResults, Params, ScriptName){
 var SdParams = Params;
 SdParams.Id = Result.Id;
 SdParams.TotalSd = TotalResults;
 return '<tr><td class="BTRsd">' + PAGlink('EditSampleData', SdParams, Result.Index+1) +
  '<td class="BTRreason"><div>' + (Result.ErrorMessage ? '<span class="BTRerrorMessage">' + Result.ErrorMessage + '</span>' : 'Main function returned false.') +
  '<td>' + PAGlink('OpenEditor', MAPretrieveParams("lua_editor", Params), 'View in Script...');
}

function BTRbutton(Page, Text, Params, Condition){
 if (Condition){
  return PAGlink(Page, Params, Text);
 }
 else{
  return '<a class="BTRdisabled">' + Text + '</a>';
 }
}

function BTRrenderResultsView(Response, Params){
 if (Response.ErrorMessage){
  MPRapp.renderError(Response.ErrorMessage); 
  return;
 }
 
 var ChannelGuid = Response.ChannelGuid;
 var H = MAPretrieveHeaderHTML("bulk_tests", Params);
 
 var CurrentChunk = Response.Chunk;
 var LastChunk = Response.CountOfChunk-1;
 var ChunkText = Response.CountOfResult + ' Failures';
 if (Response.CountOfResult) ChunkText = (Response.ChunkBegin+1) + ' to ' + (Response.ChunkEnd+1) + ' of ' + ChunkText;
 H += '<div class="content_main">';

 Params.Chunk = 0;
 var NavButton1 = BTRbutton('BulkTestResults', '&lt;&lt;', Params, (CurrentChunk > 0));
 Params.Chunk = Math.max(0, CurrentChunk-1);
 var NavButton2 = BTRbutton('BulkTestResults', '&lt;', Params, (CurrentChunk > 0));
 Params.Chunk = Math.min(LastChunk, CurrentChunk+1);
 var NavButton3 = BTRbutton('BulkTestResults', '&gt;', Params, (CurrentChunk < LastChunk));
 Params.Chunk = LastChunk;
 var NavButton4 = BTRbutton('BulkTestResults', '&gt;&gt;', Params, (CurrentChunk < LastChunk));
 delete Params.Chunk;

 H += '<div class="BTRnavPane">';
 H += BTNwrapper(NavButton1 + NavButton2 + '<span class="SPDnavText">' + ChunkText + '</span>' + NavButton3 + NavButton4) + '</div>';
 H += '<div class="BTRdataTable"><table id="bulk_test_results_table" class="BTRdataTable"><tr>'
   +  '<th>Sample Data<th class="BTRreason">Reason<th>Script';
 
 var CountOfRow = Response.Results.length;
 var ScriptName = Response.ScriptName;
 for (var Row = 0; Row < CountOfRow; Row++){
  H += BTRresultRow(Response.Results[Row], Response.TotalSd, Params, ScriptName);
 }
 H += '</table></div></div>';
 
 $('body').html(H);
 
 var NavPane = $('div.BTRnavPane');
 
 function BTRdisableNavPane(){
  NavPane.fadeTo('fast', 0.5);
  NavPane.append('<div class="BTRnavPaneBlocker"><img src="/js/mapper/images/spinner_wide.gif" /></div>');
  NavPane.find('div.BTRnavPaneBlocker img').fadeIn('slow');
 }
 
 NavPane.find('a').click(function(EventObj){ if (this.href != '') BTRdisableNavPane(); });
 
 if (Response.CountOfResult) NavPane.find('span.BTRnavText').click(function(EventObj){
  var Div = $('div.BTRgoto');
  if (Div.size()){
   Div.remove();
  }else{
   Div = $('<div class="BTRgoto">Go to <input type="text" class="BTRgotoInput" /><img src="/js/mapper/images/ok.png" /></div>');
   $('body').append(Div);
   var NavPaneOffset = NavPane.offset();
   Div.css('left', NavPaneOffset.left + (NavPane.outerWidth() - Div.outerWidth())/2);
   Div.css('top',  NavPaneOffset.top + NavPane.outerHeight());
   
   var Input = Div.find('input');
   Input.val(Response.ChunkBegin+1);
   Input.focus();
   Input.select();
   
   function BTRonGoto(EventObj){
    var NewBtr = parseInt(Input.val());
    if (isNaN(NewBtr) || NewSd < 1){
     NewBtr = 1;
    }else if (NewBtr > Response.CountOfMessage){
     NewBtr = Response.CountOfMessage;
    }
    NewBtr--;
    if (Response.Index != NewBtr){
     window.location = PAGhref('BulkTestResult', {'ChannelGuid':ChannelGuid, 'Index':NewBtr});
     BTRdisableNavPane();
    }
    Div.remove();
   }
   
   Input.keydown(function(EventObj){
    if      (EventObj.keyCode == '13') BTRonGoto(EventObj);
    else if (EventObj.keyCode == '27') Div.remove();
   });
   
   Div.find('img').click(BTRonGoto);
  }
 });
}
