function PRJinitProjectManager(Editor, Pane){
 Pane.html('<div class="PRJtitle">Project Files</div><div id="PRJcontents" />');
 var ProjectManager = Pane.find('#PRJcontents');
 ProjectManager.mouseover(function(){
  // Clear any context menus currently showing.
  $('div.PRJfileContextMenu').remove();
 });
 Editor.ifware.ProjectManager = ProjectManager;
}

function PRJonFolderToggled(ArrayWrapper, NodeTextSpan, NodeChildrenContainer, Expanded){
 if (Expanded){
  PRJappendFileNodes(NodeChildrenContainer, ArrayWrapper);
 }
}

function PRJonFileClicked(FileData, NodeSpan, NodeChildren){
 $(NodeSpan).addClass('w');
 NISonFileChanged(FileData.editor, FileData.label);
}

function PRJdiffFile(File, FileNode){
 SCMshowDiffRequest(File.editor, '', '', File.label, "", {modal:true, showWaiting:true, friendlyError:true});
}

function PRJshouldShowDiff(File, FileNode){
 return File.status != 'unchanged' && File.status != 'new';
}

function PRJimportMainFile(File){
 NISsave(File.editor, function(Editor){ SCMimportProjectAndData(Editor, false)});
}

function PRJdoRemoveFile(File, FileNode, Dialog){
 Dialog.html('<img src="/js/mapper/images/spinner.gif" /> Removing ' + PAGhtmlEscape(File.label) + '...');
 Dialog.dialog('option', 'buttons', {}); // remove buttons
 Dialog.bind('dialogbeforeclose', function(){ return false; }); // prevent closing
 
 var PostVariables = {};
 PostVariables.ChannelGuid = File.editor.ifware.ChannelGuid;
 PostVariables.File = File.label;
 
 Ajax.post('/remove_project_file', PostVariables, function(Response, TextStatus, RequestObject){
  Dialog.unbind('dialogbeforeclose'); // allow closing
  if (Response.ErrorMessage){
   Dialog.html('<span class="PRJerror">' + Response.ErrorMessage + '</span>');
   Dialog.dialog('option', 'buttons', {'OK':function(){ Dialog.dialog('close'); }});
  } else {
   Dialog.dialog('close');
   FileNode.remove();
   var Editor = File.editor;
   if (File.current){
    NISonFileChanged(Editor, Editor.ifware.MainLuaFile);
   } else {
    NISupdateAnnotations(Editor);
   }
  }
 }, 'json');
}

function PRJremoveFile(File, FileNode){
 $('#EDTconfirmDialog').remove();
 
 var Buttons = {};
 Buttons['No'] = function(){
  $(this).dialog('close');
 }
 Buttons['Yes'] = function(){
  PRJdoRemoveFile(File, FileNode, $(this));
 }
 
 $('<div id="EDTconfirmDialog"><p>Are you sure you want to remove this file from the project?</p>\
    <p>Warning: if the file is still in use by your script, it will be automatically added to the project again.</div>')
  .appendTo('body')
  .dialog({
   title:'Remove File', width:375, modal:true, draggable:false, resizable:false, buttons:Buttons
  });
}

function PRJdownloadFile(Link, File){
 Link.attr('target', '_blank');
 Link.attr('href', '/download_project_file?File=' + encodeURIComponent(File.label));
}

// Returns true if the extensions are the same.
// Otherwise, displays a confirmation dialog.
// OnContinue will be called if the user continues past the confirmation.
//
function PRJcheckExtension(File, FileInput, OnContinue){
 var ExtensionRegex = /\.\w+$/;
 var OldExtension = ExtensionRegex.exec(File.label);
 var NewExtension = ExtensionRegex.exec(FileInput.val());
 OldExtension = OldExtension ? OldExtension[0] : 'no extension';
 NewExtension = NewExtension ? NewExtension[0] : 'no extension';
 if (OldExtension == NewExtension){
  return true;
 } else {
  $('#PRJextensionWarning').remove();
  var Confirmation = $('<div id="PRJextensionWarning">\
                         <p class="PRJerror">The file extension of the existing file (' + OldExtension + ') does not match the extension of the new file (' + NewExtension + ').</p>\
                         <p>Are you sure you want replace the contents of ' + PAGhtmlEscape(File.label) + ' with the contents of the new file?</p>\
                        </div>').appendTo('body');
  var Buttons = {};
  Buttons['No'] = function(){
   Confirmation.dialog('close');
  }
  Buttons['Yes'] = function(){
   Confirmation.dialog('close');
   if (OnContinue) OnContinue();
  }
  
  Confirmation.dialog({
   modal: false,
   width: 'auto',
   title: 'File Extensions Don\'t Match',
   draggable: false,
   resizable: false,
   buttons: Buttons
  });
  
  return false;
 }
}

function PRJdoUploadFile(File, Form, FileInput, Dialog, IgnoreExtensions){
 var OnContinue = function(){
  PRJdoUploadFile(File, Form, FileInput, Dialog, true);
 };
 if (!IgnoreExtensions && !PRJcheckExtension(File, FileInput, OnContinue)){
  return;
 }
 
 Dialog.dialog('option', 'buttons', {}); // remove 'Cancel' button
 Dialog.bind('dialogbeforeclose', function(){ return false; }); // prevent closing
 AFUuploadFile('/upload_project_file', Form, function(){
  FileInput.attr('disabled', 'disabled').after('<img src="/js/mapper/images/spinner.gif" />');
 }, function(Response){
  Dialog.unbind('dialogbeforeclose'); // allow closing
  if (Response.ErrorMessage){
   Dialog.html('<span class="PRJerror">' + Response.ErrorMessage + '</span>');
   Dialog.dialog('option', 'buttons', {'OK':function(){ Dialog.dialog('close'); }});
  } else {
   Dialog.dialog('close');
   // Only update annotations if the file uploaded was a VMD.
   if (File.type == 'vmd') NISupdateAnnotations(File.editor);
  }
 });
}

function PRJuploadFile(File, FileNode){
 $('#PRJuploadDialog').remove();
 var DialogH = '<div id="PRJuploadDialog">\
                 <form>\
                  <input type="file" name="NewFile" />\
                  <input type="hidden" name="ChannelGuid" value="' + File.editor.ifware.ChannelGuid + '" />\
                  <input type="hidden" name="FileLabel" value="' + PAGhtmlEscape(File.label) + '" />\
                 </form>\
                </div>';
 var Dialog = $(DialogH).appendTo('body');
 
 var Form = Dialog.find('form');
 Form.find('input[type="file"]').change(function(){
  PRJdoUploadFile(File, Form, $(this), Dialog);
 });
 
 Dialog.dialog({
  modal: true,
  title: 'Replace ' + PAGhtmlEscape(File.label),
  minHeight: 85,
  resizable: false,
  buttons: {'Cancel':function(){ Dialog.dialog('close'); }}
 });
}

var PRJoptionDiff     = {name:'Diff',       className:'PRJoptionDiff',     func:PRJdiffFile, shouldShowFunc:PRJshouldShowDiff};
var PRJoptionImportMainFile = {name:'Import From Other Projects', className:'PRJoptionUpload', func:PRJimportMainFile};
var PRJoptionRemove   = {name:'Remove',     className:'PRJoptionRemove',   func:PRJremoveFile};
var PRJoptionDownload = {name:'Get...',     className:'PRJoptionDownload', hrefFunc:PRJdownloadFile};
var PRJoptionUpload   = {name:'Replace...', className:'PRJoptionUpload',   func:PRJuploadFile};

function PRJaddFileToProject(Editor, FileLabel, IsModule){
 var PostVariables = {'ChannelGuid':Editor.ifware.ChannelGuid, 'FileLabel':FileLabel, 'IsModule':IsModule};
 Ajax.post('/add_project_file', PostVariables, function(Response, TextStatus, RequestObject){
  if (Response.ErrorMessage){
   // Upload was successful, but we couldn't add it to the project.
   console.log(Response.ErrorMessage);
  } else if (Response.file_info) {
   PRJrefreshProjectManager(Response.file_info, Editor);
   NISupdateAnnotations(Editor);
  }
 }, 'json');
}

function PRJdoNewFileUpload(Dialog, Form, FileInput, Editor){
 Dialog.dialog('option', 'buttons', {}); // remove 'Cancel' button
 Dialog.bind('dialogbeforeclose', function(){ return false; }); // prevent closing
 AFUuploadFile('/upload_project_file', Form, function(){
  FileInput.attr('disabled', 'disabled').after('<img src="/js/mapper/images/spinner.gif" />');
 }, function(Response){
  Dialog.unbind('dialogbeforeclose'); // allow closing
  if (Response.ErrorMessage){
   Dialog.html('<span class="PRJerror">' + Response.ErrorMessage + '</span>');
   Dialog.dialog('option', 'buttons', {'OK':function(){ Dialog.dialog('close'); }});
  } else {
   Dialog.dialog('close');
   PRJaddFileToProject(Editor, Response.FileLabel, 'false');
  }
 });
}

function PRJnewModuleError(Dialog, Input, ErrorMessage){
 Dialog.find('#PRJnewModuleError').text(ErrorMessage);
 Input.get(0).focus();
 return true;
}

function PRJdoAddNewModule(Dialog, Button, Input, Editor){
 var FileLabel = jQuery.trim(Input.val());
 if (FileLabel == ''){
  PRJnewModuleError(Dialog, Input, 'You must enter a name for the new module.');
 } else {
  Input.attr('disabled', 'disabled');
  Button.css('display', 'none').after('<img src="/js/mapper/images/spinner.gif" />');
  Dialog.bind('dialogbeforeclose', function(){ return false; }); // prevent closing
  Ajax.post('/add_new_module', {'ChannelGuid':Editor.ifware.ChannelGuid, 'FileLabel':FileLabel}, function(Response, TextStatus, RequestObject){
   Dialog.unbind('dialogbeforeclose'); // allow closing
   if (Response.ErrorMessage){
    Input.attr('disabled', '');
    Button.css('display', '').next().remove();
    PRJnewModuleError(Dialog, Input, Response.ErrorMessage);
   } else {
    Dialog.dialog('close');
    PRJrefreshProjectManager(Response.file_info, Editor);
    NISupdateAnnotations(Editor);
   }
  });
 }
}

function PRJdoAddExistingFile(Dialog, FileSelector, IsModule, Editor){
 var FileLabel = FileSelector.val();
 if (FileLabel == ''){
  return; // user didn't actually select anything
 } else {
  FileSelector.attr('disabled', 'disabled').after('<img src="/js/mapper/images/spinner.gif" />');
  Dialog.bind('dialogbeforeclose', function(){ return false; }); // prevent closing
  var PostParameters = {'ChannelGuid':Editor.ifware.ChannelGuid, 'FileLabel':FileLabel, 'IsModule':IsModule};
  Ajax.post('/add_project_file', PostParameters, function(Response, TextStatus, RequestObject){
   Dialog.unbind('dialogbeforeclose'); // allow closing
   if (Response.ErrorMessage){
    Dialog.html('<span class="PRJerror">' + Response.ErrorMessage + '</span>');
    Dialog.dialog('option', 'buttons', {'OK':function(){ Dialog.dialog('close'); }});
   } else {
    Dialog.dialog('close');
    PRJrefreshProjectManager(Response.file_info, Editor);
    NISupdateAnnotations(Editor);
   }
  });
 }
}

function PRJinFileSet(FileLabel, FileSet){
 for (var i = 0; i < FileSet.length; i++){
  if (FileLabel == FileSet[i].label){
   return true;
  }
 }
 return false;
}

function PRJaddOtherFile(Editor, CurrentFiles){
 Ajax.post('/get_all_other_files', {}, function(Response, TextStatus, RequestObject){
  var AddExistingH;
  if (Response.ErrorMessage){
   AddExistingH = '<span class="PRJerror">Could not retrieve list of existing files. Reason:<br />' + Response.ErrorMessage + '</span>';
  } else if (!Response.length){
   AddExistingH = 'There are no existing files.';
  } else {
   AddExistingH = '<select><option value="">Select an existing file...</option>';
   for (var i = 0; i < Response.length; i++){
    if (!PRJinFileSet(Response[i], CurrentFiles)){
     var EscapedFile = PAGhtmlEscape(Response[i]);
     AddExistingH += '<option value="' + EscapedFile + '">' + EscapedFile + '</option>';
    }
   }
   AddExistingH += '</select>';
  }
  
  $('#PRJaddOtherFileDialog').remove();
  var DialogH = '<div id="PRJaddOtherFileDialog">\
                  <h1>Add a new file:</h1>\
                  <form>\
                   <input type="file" name="NewFile" />\
                   <input type="hidden" name="ChannelGuid" value="' + Editor.ifware.ChannelGuid + '" />\
                  </form><br>\
                  <h1>Add an existing file:</h1>' +
                  AddExistingH + '\
                 </div>';
  var Dialog = $(DialogH).appendTo('body').dialog({
   modal: true,
   title: 'Add File',
   resizable: false,
   buttons: {'Cancel':function(){
    $(this).dialog('close');
   }}
  });
  
  var Form = Dialog.find('form');
  Form.find('input[type="file"]').change(function(){
   PRJdoNewFileUpload(Dialog, Form, $(this), Editor);
  });
  Dialog.find('select').change(function(){
   PRJdoAddExistingFile(Dialog, $(this), 'false', Editor);
  });
 });
}

function PRJaddSharedFile(Editor, CurrentFiles){
 Ajax.post('/get_all_shared_files', {}, function(Response, TextStatus, RequestObject){
  var AddExistingH;
  if (Response.ErrorMessage){
   AddExistingH = '<span class="PRJerror">Could not retrieve list of existing modules. Reason:<br />' + Response.ErrorMessage + '</span>';
  } else if (!Response.length){
   AddExistingH = 'There are no existing modules.';
  } else {
   AddExistingH = '<select><option value="">Select an existing module...</option>';
   for (var i = 0; i < Response.length; i++){
    if (!PRJinFileSet(Response[i], CurrentFiles)){
     var EscapedFile = PAGhtmlEscape(Response[i]);
     AddExistingH += '<option value="' + EscapedFile + '">' + EscapedFile + '</option>';
    }
   }
   AddExistingH += '</select>';
  }
  
  $('#PRJaddOtherFileDialog').remove();
  var DialogH = '<div id="PRJaddSharedFileDialog">\
                  <h1>Create a new module:</h1>\
                  <table><tr>\
                   <td><input type="text" />\
                   <td><div class="BTNbuttons"><a id="PRJsubmitNewShared" href="#">Create</a>\
                  </table>\
                  <p id="PRJnewModuleError" class="PRJerror"></p>\
                  <h1>Add an existing module:</h1>' +
                  AddExistingH + '\
                 </div>';
  var Dialog = $(DialogH).appendTo('body').dialog({
   modal: true,
   title: 'Add Module',
   resizable: false,
   buttons: {'Cancel':function(){
    $(this).dialog('close');
   }}
  });
  
  Dialog.find('#PRJsubmitNewShared').click(function(EventObj){
   EventObj.preventDefault();
   PRJdoAddNewModule(Dialog, $(this), Dialog.find('input[type="text"]'), Editor);
  }).end()
  .find('select').change(function(){
   PRJdoAddExistingFile(Dialog, $(this), 'true', Editor);
  });
 });
}

function PRJopenFileContextMenu(Event){
 Event.stopPropagation();
 
 var FromImage = $(this).find('img');
 var Position = FromImage.offset();
 if (!Position) return;
 
 // Clear any context menus currently showing.
 $('div.PRJfileContextMenu').remove();
 
 // Create new menu
 var Menu = $('<div class="PRJfileContextMenu"><div class="PRJleft" /><div class="PRJinner" /></div>');
 
 var Table = Menu.find('div.PRJinner');
 var File = Event.data;
 var FileNode = FromImage.closest('li');
 for (var i = 0; i < File.options.length; i++){
  var Option = File.options[i];
  var shouldShowFunc = Option.shouldShowFunc;
  if (!shouldShowFunc || shouldShowFunc(File, FileNode)){
   var ActionLink = $('<a href="#"><div class="' + Option.className + '">' + Option.name + '</div></a>').appendTo(Table);
   if (Option.hrefFunc) Option.hrefFunc(ActionLink, File);
   ActionLink.bind('click', Option,
    function(Event){
     Menu.remove();
     if (Event.data.func){
      Event.preventDefault();
      Event.data.func(File, FileNode);
     } else if(window.MiniLogin && !MiniLogin.loggedIn()) {
      Event.preventDefault();
     }
   });
  }
 }
 
 Menu.appendTo(document.body)
  .bind('mouseleave', Menu, PRJcloseFileContextMenu);
 
 Menu.css('left', (Position.left + 15) + 'px');
 Menu.css('top', (Position.top - 5) + 'px');
 Menu.fadeIn('fast');
}

function PRJcloseFileContextMenu(Event){
 var Menu = $(Event.data);
 Menu.remove();
}

function PRJcreateFileNode(File, Editor, CanSelect, MenuOptions){
 File.editor = Editor;
 File.options = MenuOptions;
 
 // TODO we can also specify the file's state (modified, new, etc).
 var FileClass = 'PRJfile PRJft_' + File.type + ' PRJfs_' + File.status;
 if (File.current){
  FileClass += ' c';
 }
 if (CanSelect){
  FileClass += ' s';
 }
 
 var FileNodeH = PAGhtmlEscape(File.label) + ' <a class="PRJcontextMenuButton"><img src="/js/treeview/images/arrow-contracted.gif" /></a>';
 
 var FileNode = TRVcreateNode(File, '', FileClass, false, false, FileNodeH, null, CanSelect ? PRJonFileClicked : null);
 $(FileNode).find('a.PRJcontextMenuButton')
  .bind('mouseenter', File, PRJopenFileContextMenu);
 return FileNode;
}

function PRJappendFileNodes(ChildContainer, ArrayWrapper, MenuOptions){
 var FileArray = ArrayWrapper.files;
 for (var i = 0; i < FileArray.length; i++){
  ChildContainer.appendChild(PRJcreateFileNode(FileArray[i], ArrayWrapper.editor, ArrayWrapper.canSelect, MenuOptions));
 }
}

function PRJrefreshProjectManager(Info, Editor){
 var Container = Editor.ifware.ProjectManager;

 // We're going to replace the entire tree, so we need to remember which folders are expanded.
 var SharedExpanded = !Container.find('li.shared').hasClass('expandable');
 var OtherExpanded = !Container.find('li.other').hasClass('expandable');

 var FileTree = document.createElement('ul');
 FileTree.className = 'ifwareTreeview';
 
 // Main file
 FileTree.appendChild(PRJcreateFileNode(Info.main, Editor, true, [PRJoptionDiff,PRJoptionImportMainFile]));
 
 // Shared files
 var SharedArrayWrapper = {files:Info.shared, editor:Editor, canSelect:true};
 var SharedFolder = TRVcreateNode(SharedArrayWrapper, 'shared', 'PRJfolder', true, SharedExpanded, 'shared [<a href="#" id="PRJaddShared">Add...</a>]', PRJonFolderToggled);
 if (SharedExpanded){
  PRJappendFileNodes(TRVgetChildContainer(SharedFolder), SharedArrayWrapper, [PRJoptionDiff, PRJoptionRemove]);
 }
 FileTree.appendChild(SharedFolder);
 
 // Other files
 var OtherArrayWrapper = {files:Info.other, editor:Editor, canSelect:false};
 var OtherFolder = TRVcreateNode(OtherArrayWrapper, 'other', 'PRJfolder', true, OtherExpanded, 'other [<a href="#" id="PRJaddOther">Add...</a>]', PRJonFolderToggled);
 if (OtherExpanded){
    var OtherMenuOptions  =[PRJoptionDownload, PRJoptionUpload, PRJoptionDiff, PRJoptionRemove];
    if (MPRapp && MPRapp.ExtraOtherFileMenuOptions){
       OtherMenuOptions = OtherMenuOptions.concat(MPRapp.ExtraOtherFileMenuOptions);
    }
    PRJappendFileNodes(TRVgetChildContainer(OtherFolder), OtherArrayWrapper, OtherMenuOptions);
 }
 FileTree.appendChild(OtherFolder);

 Container.empty().append(FileTree)
  .find('a#PRJaddOther').click(function(EventObj){
   EventObj.preventDefault();
   EventObj.stopPropagation();
   PRJaddOtherFile(Editor, Info.other);
  }).end()
  .find('a#PRJaddShared').click(function(EventObj){
   EventObj.preventDefault();
   EventObj.stopPropagation();
   PRJaddSharedFile(Editor, Info.shared);
  });
}

function PRJrequestProjectManagerRefresh(Editor){
 Ajax.post('/project_files', {'ChannelGuid':Editor.ifware.ChannelGuid}, function(Response, TextStatus, RequestObject){
  // Not worth reporting an error if this fails.
  if (!Response.ErrorMessage){
   PRJrefreshProjectManager(Response.file_info, Editor);
  }
 });
}
