function SCMviewMilestonesDlg(Editor) {
    SCMgetProjectFilesRequest(Editor, SCMviewMilestonesRequest);
}

function SCMsaveMilestoneDlg(Editor) {
   SCMgetProjectFilesRequest(Editor, SCMsaveMilestoneDlgUI);
}

function SCMgetLastMilestonName(Editor, Callback) {
   Ajax.post('/source_control', { 'RequestType': 'milestone_list', 'ChannelGuid': Editor.ifware.ChannelGuid },
         function(Response, TextStatus, RequestObject) {
            if (SCMresponseDlgUI(Response, false)) {
               
            } else {
               if (Response.Milestones.length == 0) {
                  Callback ('');
               } else {
                  Callback (Response.Milestones[0].MilestoneName);
               }
            }
         }, 'json');
}

function SCMviewMilestonesRequest(Editor, ProjectData) {
   Ajax.post('/source_control', { 'RequestType': 'milestone_list', 'ChannelGuid': Editor.ifware.ChannelGuid },
         function(Response, TextStatus, RequestObject) {
            if (SCMresponseDlgUI(Response, false)) {
               
            } else {
               SCMopenMilestonesDlgUI(Editor, Response, ProjectData);
            }
         }, 'json');
}

function SCMsaveMilestoneDlgUI(Editor, ProjectData) {
   var FileLabelArray = SCMgetProjectLabelList(ProjectData);

   if ($('#fossilCommitDlg').length) {
      $('#fossilCommitDlg').remove();
   }
   $(document).find("body").append('<div id="fossilCommitDlg"><form id="commitForm">Milestone name: <input id="revisionName" type="text" name="Name"/><div id="milestone_name_error" class="fossil_error_inline"></div></form></div>');

   var CommitPopup = $("#fossilCommitDlg");

   var DlgButtons = {};
   DlgButtons['Save'] = function SCMsaveButtonCallback() {
      $('#milestone_name_error').text('');
      SCMsaveMilestoneAction(Editor, CommitPopup, FileLabelArray);
   }
   DlgButtons['Cancel'] = function() { $(this).dialog('close'); }

   // TODO: properly dimension the dialog based on the parent 
   CommitPopup.dialog({
      bgiframe: true,
      width: 300,
      title: "Save Milestone",
      position: 'center',
      modal: true,
      autoOpen: false,
      buttons: DlgButtons
   });

   CommitPopup.dialog("open");

   var RevisionNameBox = CommitPopup.find('#revisionName');
   
   RevisionNameBox.val((new Date()).toDateString());
   RevisionNameBox.focus();
   RevisionNameBox.select();

   var CommitForm = CommitPopup.find('#commitForm');
   CommitForm.keypress(function(e) {
      if (e.which == 13) {
         SCMsaveMilestoneAction(Editor, CommitPopup, FileLabelArray);
         e.preventDefault();
      }
   });
   CommitPopup.prepend($("<br/>"));

   CommitPopup.find('#fileTable').remove();

   SCMgetFilesTable(Editor, "fileTable", ProjectData, function(Tables) {
      CommitPopup.prepend(Tables);
   }) 
}

function SCMopenMilestonesDlgUI(Editor, Response, ProjectData) {
   var FileLabelArray = SCMgetProjectLabelList(ProjectData);

   if ($('#fossilRevisionsDlg').length) {
      $('#fossilRevisionsDlg').remove();
   }
   $(document).find("body").append('<div id="fossilRevisionsDlg"></div>');
   var fossilRevisions = $("#fossilRevisionsDlg");

   var Milestones = Response.Milestones;

   DlgButtons = {};
   DlgButtons['Close'] = function() { $(this).dialog('close'); }

   // TODO: properly dimension the dialog based on the parent 
   fossilRevisions.dialog({
      bgiframe: true,
      width: 750,
      title: 'Milestones',
      modal: true,
      position: 'center',
      autoOpen: false,
      buttons: DlgButtons
   });

   var H = "";

   if (Milestones.length == 0) {
      H += "<div id='milestone_list_title'>No Saved Milestones</div>";
      H += "Use 'Save Milestone' to add a snapshot of all files to the source control repository.";
      $('#fossilRevisionsDlg').html(H);
   } else {
   H += '<table id="tag_list" class="diffTable"><tr><th class="milestone">Milestone</th><th class="time">Time</th><th class="user">User</th><th class="files">Files</th></tr></table>';
   $('#fossilRevisionsDlg').html(H);

   var TagListTable = $('#fossilRevisionsDlg').find('#tag_list').first();
      if (TagListTable.length > 1) {
         alert('problem. FileInfoTable.length = ' + TagListTable.length);
      }

      var FileLabelArray = SCMgetProjectLabelList(ProjectData);

      var i;
      for (i = 0; i < Milestones.length; i++) {
         var Milestone = Milestones[i];

         var jH = SCMprependTagInfo(Editor, Milestone.MilestoneName, Milestone.TimeStamp, Milestone.UserName, ProjectData);
         TagListTable.append(jH);
      }
   }

   fossilRevisions.dialog("open");
}

function SCMcreateDiffDialog(Editor, DiffContent, FileLabels, Options, MilestoneName) {
   if ($('#fossilDiff').length) {
      $('#fossilDiff').remove();
   }
   
   $(document).find("body").append($('<div id="fossilDiff"></div>'));
   var DiffPopup = $("#fossilDiff");

   var DlgButtons = {};
   DlgButtons['Close'] = function() { $(this).dialog('close'); }

   $('#fossilDiff').html(DiffContent);

   var DialogWidth = $(window).width() * 0.9;
   var DialogHeight = $(window).height() * 0.9;

   var MoveToFront = $('#toggleButton');
   MoveToFront.remove();
   DiffPopup.prepend(MoveToFront);

   MoveToFront = $('.legendTable');
   MoveToFront.remove();
   DiffPopup.prepend(MoveToFront);

   if (DiffPopup.find('#condensed').length > 0) {
      var SideBySideViewLabel = 'Side by side';
      var CondensedViewLabel = 'Line over line';

      var SwitchView = $('<span id="switch_view" class="clickable_link">' + CondensedViewLabel + '</span>');
      DiffPopup.find('#toggleButton').append(SwitchView);

      SwitchView.click(function() {
         if ($('#switch_view').text() == SideBySideViewLabel) {
            DiffPopup.find('#condensed').hide();
            DiffPopup.find('#sideBySide').show();
            ToggleUnchanged.show();
            $('#switch_view').text(CondensedViewLabel);
         } else {
            DiffPopup.find('#condensed').show();
            DiffPopup.find('#sideBySide').hide();
            ToggleUnchanged.hide();
            $('#switch_view').text(SideBySideViewLabel);
         }
      });

      var ShowUnchangedLabel = 'Show everything';
      var HideUnchangedLabel = 'Show changes only';
            
      var ToggleUnchanged = $('<span id="toggle_unchanged" class="clickable_link">' + HideUnchangedLabel + '</span>');
      DiffPopup.find('#toggleButton').append(ToggleUnchanged);

      ToggleUnchanged.click(function() {
         if ($('#toggle_unchanged').text() == HideUnchangedLabel) {
            $('table').find('.uc').hide();
            $('#toggle_unchanged').text(ShowUnchangedLabel);
         } else {
            $('table').find('.uc').show();
            $('#toggle_unchanged').text(HideUnchangedLabel);
         }
      });
   } else {
      DialogWidth = 300;
      DialogHeight = 150;
   }

   if (MilestoneName == '') {
      SCMgetLastMilestonName(Editor, function(Name) {
         $('#milestoneNameSideBySide').text('Milestone: ' + PAGhtmlEscape(Name));
         $('#milestoneNameLineOverLine').text(PAGhtmlEscape(Name));
      });
   }

   DiffPopup.find('#sideBySide #diff_header_row').append($('<th class="lineNumber"></th><th id="milestoneNameSideBySide">' + PAGhtmlEscape(MilestoneName) + '</th><th class="lineNumber"></th><th>Current</th>'));
   DiffPopup.find('#condensed #diff_header_row').append($('<th class="lineNumber" id="milestoneNameLineOverLine">' + PAGhtmlEscape(MilestoneName) + '</th><th class="lineNumber">Current</th><th>Differences</th>'));
   DiffPopup.find('#condensed').hide();

   // TODO: properly dimension the dialog based on the parent 
   DiffPopup.dialog({
      width: DialogWidth,
      height: DialogHeight,
      title: "Diff for " + PAGhtmlEscape(FileLabels),
      modal: Options.modal,
      autoOpen: false,
      position: 'center',
      buttons: DlgButtons
   });
   
   DiffPopup.dialog("open");
}

// Valid options:
//  * short - default: false
//  * modal - default: false
//  * showWaiting - specifies whether a dialog should be shown while we're waiting. default: false
//  * friendlyError - specifies whether we should give a simple friendly message if error code 2
//                    (not in repository) occurs. default: false
//
function SCMshowDiffRequest(Editor, CommitToCompare, MilestoneName, FileLabels, FileType, Options) {
   SCMdialogWaiting('#fossilRevisionsDlg, #fossilCommitDlg', true);

   if (!Options.modal){
      Options.modal = false;
   }
   if (!Options.friendlyError){
      Options.friendlyError = false;
   }
   
   var WaitingPopup = null;
   if (Options.showWaiting){
      $('#fossilDiffWaiting').remove();
      WaitingPopup = $('<div id="fossilDiffWaiting"></div>').appendTo('body');
      WaitingPopup.html('<img src="/js/mapper/images/spinner.gif" /> Generating diff for ' + PAGhtmlEscape(FileLabels) + '...');
      
      WaitingPopup.dialog({
         title: "Diff for " + PAGhtmlEscape(FileLabels),
         position: 'center',
         modal: Options.modal,
         minHeight: 70,
         draggable: false,
         resizable: false,
         beforeClose: function() { return false; } // prevent closing
      });
   }

   Ajax.post('/source_control', { 'RequestType': 'diff', 'FileLabels': FileLabels, 'FileTypes': FileType, 'Commit': CommitToCompare, 'ChannelGuid': Editor.ifware.ChannelGuid },
         function(Response, TextStatus, RequestObject) {
            SCMdialogWaiting('#fossilRevisionsDlg, #fossilCommitDlg', false);
            if (WaitingPopup) {
               WaitingPopup.unbind('dialogbeforeclose'); // allow closing
               WaitingPopup.dialog('close');
            }
            if (Response.ErrorCode == 2 && Options.friendlyError) {
               $('#fossilResponseDlg').remove();
               var Popup = $('<div id="fossilResponseDlg">This is a new file, which must be saved as part of a milestone before a diff can be performed.</div>').appendTo('body');
               var DlgButtons = {};
               DlgButtons['Close'] = function() { $(this).dialog('close'); }
               Popup.dialog({ title: "Nothing to Diff", modal: true, resizable: false, buttons: DlgButtons });
            }
            else if (SCMresponseDlgUI(Response, false, function() { SCMdialogWaiting('#fossilCommitDlg', false); })) {

            } else {
               if (CommitToCompare == '') {
                  MilestoneName = '';
               } else {
                  MilestoneName = 'Milestone: ' + MilestoneName;
               }
               SCMcreateDiffDialog(Editor, Response.DiffContent, FileLabels, Options, MilestoneName);
            }
         }, 'json');
}

function SCMfindLabel(Label, Array) {
   for (var i = 0; i < Array.length; i++) {
      if (Array[i] == Label) {
         return true;
      }
   }
   return false;
}

function SCMrevertRequest(Editor, CommitToCompare, FileLabel, FileType) {
   SCMdialogWaiting('#fossilRevisionsDlg', true);
   Ajax.post('/source_control', { 'RequestType': 'revert', 'FileLabels': FileLabel, 'FileTypes': FileType, 'Commit': CommitToCompare, 'ChannelGuid': Editor.ifware.ChannelGuid },
         function(Response, TextStatus, RequestObject) {
            if (SCMfindLabel(Editor.ifware.LuaFileName, Response.RevertedFiles)) {
               NISupdateAnnotations(Editor, false, Editor.ifware.LuaFileName);
            } else {
               NISupdateAnnotations(Editor, false);
            }
            
            if (SCMresponseDlgUI(Response, false, function() { SCMdialogWaiting('#fossilRevisionsDlg', false); })) {
               return;
            }
         }, 'json');
}

function SCMpopulateTagInfo(Editor, MilestoneName, ProjectData) {
   var i = 0;

   var jH = $("<span><span id='detail_click' class='clickable_link'>Show Files</span> | <span id='milestone_revert_click' class='clickable_link'>Revert all files</span></span>");
   var DetailsClick = jH.find('#detail_click');
   DetailsClick.click(function() {
      if (jH.find('.tag_table').length > 0) {
         jH.find('.tag_table').remove();
      } else {
         SCMsourceControlTagFilesRequest(Editor, MilestoneName, jH, ProjectData); // This will make an ajax call and update jH when results are ready
      }
   });

   var MilestoneRevertClick = jH.find('#milestone_revert_click');
   MilestoneRevertClick.click(function() {
      SCMdialogConfirm (SCMrevertConfirmText (), function() {
         SCMmilestoneRevertRequest(Editor, MilestoneName, ProjectData); // This will make an ajax call and update jH when results are ready
      });
   });

   return jH;
}

function SCMprependTagInfo(Editor, MilestoneName, Time, UserName, ProjectData) {
   //   var jH = $("<tr><td class='tag_td'><pre>" + MilestoneName + "</pre></td><td class='tag_td'>" + Time + "</td><td class='file_table'> </td></tr>");
   var jH = $("<tr><td class='tag_td_milestone'>" + PAGhtmlEscape(MilestoneName) + "</td><td class='tag_td_date'>" + PAGhtmlEscape(Time) + "</td><td class='tag_td_user'>" + PAGhtmlEscape(UserName) + "</td><td class='file_table'> </td></tr>");
   jH.find(".tag_td_milestone").css({ 'white-space': 'pre-wrap' });

   jH.find(".file_table").append(SCMpopulateTagInfo(Editor, MilestoneName, ProjectData));

   return jH;
}

function SCMopenFossilUIrequest(Editor, FileLabelArray) {
   Ajax.post('/source_control', { 'RequestType': 'ui', 'FileLabels': FileLabelArray.join("\n"), 'ChannelGuid': Editor.ifware.ChannelGuid },
      function(Response, TextStatus, RequestObject) {
         if (SCMresponseDlgUI(Response, false)) {
            return;
         }
      }, 'json');
}

function SCMsourceControlDiffHandler(Editor, jH, CommitID, MilestoneName, FileLabel, FileType) {
   jH.find("#diff_click").click(function() {
      SCMshowDiffRequest(Editor, CommitID, MilestoneName, FileLabel, FileType, {});
   });
}

function SCMsourceControlRevertHandler(Editor, jH, CommitID, FileLabel, FileType) {
   jH.find("#revert_click").click(function() {
      SCMdialogConfirm(SCMrevertConfirmText(), function() {
         SCMrevertRequest(Editor, CommitID, FileLabel, FileType);
      });
   });
}

function SCMsourceControlTagFilesRequest(Editor, TagID, jAll, ProjectData) {
   SCMdialogWaiting('#fossilRevisionsDlg', true);
   Ajax.post('/source_control', { 'RequestType': 'get_files_for_tag', 'MilestoneName': TagID, 'FileLabels': SCMgetMainFileLabel(ProjectData) + "\n", 'ChannelGuid': Editor.ifware.ChannelGuid },
         function(Response, TextStatus, RequestObject) {
            if (SCMresponseDlgUI(Response, false, function() { SCMdialogWaiting('#fossilRevisionsDlg', false); })) {
               return;
            } else {
               if (Response.Files.length == 0) {
                  jAll.append($("<span>Error</span>"));
               } else {
                  var jHtml = $("<table class='tag_table'></table>");
                  for (var i = 0; i < Response.Files.length; ++i) {
                     var CommitID = Response.Files[i].CommitID;
                     var FileLabel = Response.Files[i].FileLabel;
                     var FileType = Response.Files[i].FileType;
                     var jH = $("<tr><td>" + FileLabel + "</td><td>" + "<span  id='diff_click' class='clickable_link'>Diff</span></td><td>|</td><td><span id='revert_click' class='clickable_link'>Revert</span></span></td></tr>");
                     jHtml.append(jH);

                     SCMsourceControlDiffHandler(Editor, jH, CommitID, TagID, FileLabel, FileType);
                     SCMsourceControlRevertHandler(Editor, jH, CommitID, FileLabel, FileType);
                  }
                  jAll.append(jHtml);
               }
            }
         }, 'json');
}

function SCMsaveMilestoneRequest(Editor, MilestoneName, FileLabelArray) {
   Ajax.post('/source_control', { 'RequestType': 'save_milestone', 'FileLabels': FileLabelArray.join("\n"), 'MilestoneName': MilestoneName, 'ChannelGuid': Editor.ifware.ChannelGuid },
      function(Response, TextStatus, RequestObject) {
         if (SCMresponseDlgUI(Response, false)) {
            return;
         } else {
            $("#fossilCommitDlg").dialog('close');
            PRJrequestProjectManagerRefresh(Editor);
         }
      }, 'json');
}

function SCMcheckMilestoneName(Editor, MilestoneName, FileLabelArray, CommitPopup, CallBack) {
   Ajax.post('/source_control', { 'RequestType': 'check_milestone_name', 'MilestoneName': MilestoneName, 'FileLabels': FileLabelArray.join("\n"), 'ChannelGuid': Editor.ifware.ChannelGuid },
      function(Response, TextStatus, RequestObject) {
         if (!Response.MilestoneNameUnique) {
            $('#milestone_name_error').text('Name must be unique for the channel.');
            SCMdialogWaiting('#fossilCommitDlg', false);
            return;
         } else {
            CallBack(Editor, MilestoneName, FileLabelArray);
         }
      }, 'json');
}

function SCMsaveMilestoneAction(Editor, CommitPopup, FileLabelArray) {
   var RevisionNameBox = CommitPopup.find('#revisionName');
   var MilestoneName = RevisionNameBox.val();
   if (MilestoneName.trim().length == 0) {
      $('#milestone_name_error').text('Name must not be blank.');
      SCMdialogWaiting('#fossilCommitDlg', false);
   } else {
      SCMdialogWaiting(CommitPopup, true);
      SCMcheckMilestoneName(Editor, MilestoneName, FileLabelArray, CommitPopup, SCMsaveMilestoneRequest);
   }
}

function SCMgetFileStatusRequest(Editor, FileLabelArray, ElementsToUpdate) {
   Ajax.post('/source_control', { 'RequestType': 'status', 'FileLabels': FileLabelArray.join("\n"), 'ChannelGuid': Editor.ifware.ChannelGuid },
      function(Response, TextStatus, RequestObject) {
         if (SCMresponseDlgUI(Response, false)) {
            return;
         } else {
            for (var FileLabel in Response) {
               if (Response.hasOwnProperty(FileLabel)) {
                  if (ElementsToUpdate.hasOwnProperty(FileLabel)) {

                     ElementsToUpdate[FileLabel].text('').append ($('<span>' + Response[FileLabel] + '</span>'));

                     var StatusText;
                     if (Response[FileLabel].indexOf ("EDITED") != -1) {
                        // Add a diff option
                        var jDiff = $('<span> : </span><span id="diff_click" class="clickable_link">Diff</span>');
                        ElementsToUpdate[FileLabel].append(jDiff);
                        SCMsourceControlDiffHandler(Editor, jDiff.parent(), "", "", FileLabel);
                     }

                     if (Response[FileLabel] == "NEW") {
                        // The file has been added.

                        if (FileLabelArray.indexOf(FileLabel) == -1) {
                           FileLabelArray.push(FileLabel);
                        }
                     }
                  }
               }
            }
         }
      }, 'json');
}

function SCMcheckMoreRecentCommitsRequest(Editor, FileLabelArray) {
   Ajax.post('/source_control', { 'RequestType': 'check_more_recent_commit', 'FileLabels': FileLabelArray.join("\n"), 'ChannelGuid': Editor.ifware.ChannelGuid },
      function(Response, TextStatus, RequestObject) {
         if (SCMresponseDlgUI(Response, true)) {
            return;
         } else {
            var FileArray = Response.Files;
            var i;
            for (i = 0; i < FileArray.length; ++i) {
               alert(FileArray[i] + " was modified since your last checkout.");
            }
         }
      }, 'json');
}



function SCMgetFilesTable(Editor, TableId, ProjectData, Callback) {
   var Table = $('<table id="' + TableId + '" class="filesTable"><tr><th>Files</th><th>Status</th></tr></table>');

   var i;
   var ElementsArray = new Object; 

   for (i = 0; i < ProjectData.length; ++i) {
      var RowHtml = '<tr><td>' + ProjectData[i].Label + '</td>';
      RowHtml += '<td align="center" id="FileStatus' + i + '"><img class="fossilSpinner" src="/js/mapper/images/spinner.gif" /></td>';
      RowHtml += '</tr>';
      Table.append($(RowHtml));

      ElementsArray[ProjectData[i].Label] = Table.find("#FileStatus" + i);
   }

   // Get the file status from the server
   SCMgetFileStatusRequest(Editor, SCMgetProjectLabelList(ProjectData), ElementsArray); 
   Callback(Table);
}

function SCMresponseDlgUI(Response, ShowInfo, Callback) {
   if ($('#fossilResponseDlg').length) {
      $('#fossilResponseDlg').remove();
   }

   if (Response.ErrorMessage || (Response.InfoMessage && ShowInfo)) {
      $(document).find("body").append($("<div id='fossilResponseDlg'><div class='fossil_error'></div><br/><span id='fossil_expand_output'>Show details</span><div class='fossil_output'></div><div class='fossil_info'></div></div>"));
      var ResponsePopup = $("#fossilResponseDlg");

      var DlgButtons = {};
      DlgButtons['Close'] = function() { $(this).dialog('close'); }

      // TODO: properly dimension the dialog based on the parent
      ResponsePopup.dialog({
         bgiframe: true,
         width: 600,
         title: "Response",
         modal: true,
         autoOpen: false,
         position: 'center',
         buttons: DlgButtons
      });

      var RawDetailsLink = $('#fossil_expand_output');
      RawDetailsLink.hide();

      if (Response.ErrorMessage) {
         ResponsePopup.find('.fossil_error').text(Response.ErrorMessage);
         ResponsePopup.find('.fossil_error').show();

         if (Response.RawOutput) {
            var RawOutputDiv = ResponsePopup.find('.fossil_output');
            RawDetailsLink.show();         
            RawDetailsLink.click(function() {
               RawOutputDiv.toggle();
               if (RawOutputDiv.is(':visible')) {
                  RawDetailsLink.text('Hide details');
               } else {
                  RawDetailsLink.text('Show details');
               }
            });
            RawOutputDiv.hide();
            RawOutputDiv.append(Response.RawOutput);
         }
         ResponsePopup.dialog("open");
         if (typeof Callback == 'function') Callback();
         return true;
      }
      if (Response.InfoMessage) {
         ResponsePopup.find('.fossil_error').hide();
         ResponsePopup.find('.fossil_info').text(Response.InfoMessage);
         ResponsePopup.dialog("open");
      }
   }
   if (typeof Callback == 'function') Callback();
   return false;
}

function SCMgetMainFileLabel(ProjectData) {
   for (var i = 0; i < ProjectData.length; ++i) {
      if (ProjectData[i].Type == "Main") {
         return (ProjectData[i].Label);
      }
   }
   return "";
}

function SCMgetProjectLabelList(ProjectData) {
   var FileList = new Array();
   for (var i = 0; i < ProjectData.length; ++i) {
      FileList.push(ProjectData[i].Label);
   }
   return FileList;
}

function SCMgetProjectFilesRequest(Editor, CallBack) {
   Ajax.post('/source_control', { 'RequestType': 'get_project_files', 'ChannelGuid': Editor.ifware.ChannelGuid },
      function(Response, TextStatus, RequestObject) {
         if (!Response) {
            Editor.ifware.AnnotationsStatusContainer.innerHTML = 'Server is not responding.';
            return;
         }
         if (!SCMresponseDlgUI(Response, false)) {
            // We are getting a raw list of all project data in Response.ProjectData
            CallBack(Editor, Response.ProjectData);
         }
      }, 'json');
}

function SCMmilestoneRevertRequest(Editor, MilestoneName) {
   SCMdialogWaiting('#fossilRevisionsDlg', true);
   Ajax.post('/source_control', { 'RequestType': 'checkout_milestone', 'MilestoneName': MilestoneName, 'ChannelGuid': Editor.ifware.ChannelGuid },
      function(Response, TextStatus, RequestObject) {
         SCMdialogWaiting('#fossilRevisionsDlg', false);
         NISupdateAnnotations(Editor, false, Editor.ifware.LuaFileName);
         if (SCMresponseDlgUI(Response, false, function() { SCMdialogWaiting('#fossilRevisionsDlg', false); })) {
            return;
         }
      }, 'json');
}

function SCMdialogWaiting(DialogSelector, BoolWaiting) {
   if (BoolWaiting) {
      $(DialogSelector).dialog("disable");
      $('.ui-dialog-buttonpane').prepend ($('<img class="fossilSpinner" src="/js/mapper/images/spinner.gif" />'));
   } else {
      $(DialogSelector).dialog("enable");
      $('.fossilSpinner').remove();
   }
}

function SCMdialogConfirm (ConfirmText, Callback) {
   if ($('#fossilConfirmDlg').length) {
      $('#fossilConfirmDlg').remove();
   }
   $(document).find("body").append($("<div id='fossilConfirmDlg'>" + ConfirmText + "</div>"));

   var DlgButtons = {};
   DlgButtons['No'] = function() {
      $(this).dialog('close');
   }

   DlgButtons['Yes'] = function() {
      Callback();
      $(this).dialog('close');
   }

   // TODO: properly dimension the dialog based on the parent
   var PopupDialog = $("#fossilConfirmDlg");
   
   PopupDialog.dialog({
      bgiframe: true,
      title: "Confirmation Request",
      width: 500,
      modal: true,
      autoOpen: false,
      position: 'center',
      buttons: DlgButtons
   });
   PopupDialog.dialog("open");
}

function SCMrevertConfirmText() {
   return "Revert operation might overwrite your changes. Are you sure you want to revert?";
}

function SCMimportProjectAndData(Editor) {
   var DialogId = 'importProjectAndData';
   $('#' + DialogId).remove();
   $(document).find("body")
       .append('<div id="'+DialogId+'">' +
                   '<form id="importForm">'+
                   '<table>'+
                   '<tr><td valign="top"><input type="radio" name="importType" value="EmptyProject"></td><td>Use a blank project</td>'+
                   '<tr><td valign="top"><input type="radio" name="importType" checked value="ImportProject"></td>'+
                   '    <td><label for="'+DialogId+'_projectList">Import from existing projects</label>' +
                   '        <br><select id="'+DialogId+'_projectList" name="projectList"></select>' +
                   (Editor.ifware.UsesParameter ?
                   '        <br><input id="'+DialogId+'_importSampleData" type="checkbox" checked name="importSampleData">'+
                   '        <label for="'+DialogId+'_importSampleData">Import sample data</label>':'')+
                   '</td></tr></table>' +
                   '</form>' +
                   '<div class="importError" style="color: red"></div>' +
               '</div>');

   var ImportDialog = $('#' + DialogId);
   function onToggleType(){
       var Type = $('input[name=importType]:checked',ImportDialog).val();
       var Disable = (Type == 'EmptyProject');
       $('input[name=importSampleData]',ImportDialog).attr('disabled',Disable);
       $('select[name=projectList]',ImportDialog).attr('disabled',Disable);
   }
   onToggleType();
   $('input[name=importType]',ImportDialog).click( function(){ onToggleType() } );

   var DlgButtons = {};
   DlgButtons['Import'] = function importButtonCallback() {
       if ('ImportProject' == $('input[name=importType]:checked',this).val()){
           var SourceGuid = $('select[name=projectList] option:selected',this).val();
           if (!SourceGuid) $(this).dialog('close');
           SCMdialogWaiting('#' + DialogId, true);
           var Params = {'RequestType' : 'import_from_project', 'ChannelGuid': Editor.ifware.ChannelGuid };
           Params.source_guid = SourceGuid;
           if ($('input[name=importSampleData]:checked',this).length && Editor.ifware.UsesParameter){
               Params.import_sample_data = 'true';
           }
           Ajax.post('/source_control', Params,
                  function(Response, TextStatus, RequestObject) {
                      SCMdialogWaiting('#' + DialogId, false);
                      if (Response.Error){
                          $('.importError',ImportDialog).html(Response.Error);
                      }
              else {
                  Editor.ifware.CountOfSampleData += Response.ImportCount;
                  NISupdateSampleDataControl(Editor);
                  NISupdateAnnotations(Editor, false, Editor.ifware.LuaFileName);
                  $(ImportDialog).dialog('close');
              }
                  }, 'json');       
       }
       else{
           var MainCode = '';
           if (Editor.ifware.UsesParameter){
              var MainCode = '-- The main function is the first function called from Iguana.\n\
-- The Data argument will contain the message to be processed.\n\
function main(Data)\n\
end';
           } else {
              var MainCode = '-- The main function is the first function called from Iguana.\n\
function main()\n\
end';
           }
           Editor.setCode(MainCode);
           NISupdateAnnotations(Editor, true, Editor.ifware.LuaFileName);            
           $(ImportDialog).dialog('close');
       }
   }
   DlgButtons['Cancel'] = function() { $(this).dialog('close'); }

   ImportDialog.dialog({
      bgiframe: true,
      width: 400,
      title: 'Import Project/Sample Data',
      position: 'center',
      modal: true,
      autoOpen: false,
      buttons: DlgButtons
   });

   //only open the dialog when the response comes back, in case mini login is to be displayed.
   ImportDialog.dialog("open");
   SCMdialogWaiting('#' + DialogId, true);
   Ajax.post('/source_control', {'RequestType' : 'get_all_projects_file_info','ChannelGuid': Editor.ifware.ChannelGuid},
          function(Response, TextStatus, RequestObject) {
              var ProjNames = [];
              var ProjByName = {}
              Response.Projects.sort(function(Left,Right){
                      var LeftName = (Left.Name || Left.Guid).toLowerCase();
                      var RightName = (Right.Name || Right.Guid).toLowerCase();
                      if (LeftName < RightName) return -1;
                      else if (LeftName > RightName) return 1;
                      else return 0;                      
              });
              for (ProjIndex in Response.Projects){
                  var Proj = Response.Projects[ ProjIndex ];
                  var NewOpt = $('<option></option>');
                  NewOpt.val(Proj.Guid);
                  NewOpt.html(Proj.Name || Proj.Guid);
                  $('select[name=projectList]',ImportDialog).append(NewOpt);
              } 
              SCMdialogWaiting('#' + DialogId, false);
          }, 'json');
   
}
