// Javascript routines for channel_grouping_control.cs page

// Removes selected role. 
function remove_channel_group(GroupName)
{
   document.remove_channel_group.group.value = GroupName;
   showVerifySubmitMessage("Removal Confirmation", "Are you sure you want to remove the channel group '" + GroupName + "'?", document.remove_channel_group);
}

// Changes the row color on a mouseover.
function onRowEntered(Row)
{
   Row.removeClass("dark_row").removeClass("light_row").addClass("dark_row_highlighted");
}

// Changes the row color on a mouseexit.
function onRowExited()
{
   $("li.channel_group_list_row").removeClass("dark_row_highlighted").addClass("dark_row");
   $("li.channel_group_list_row:nth-child(even)").removeClass("dark_row").addClass("light_row");
}

var RawGroupTooltipDescriptionText = "%DESCRIPTION%<br><br>";
var RawGroupTooltipMemberCountText = "Contains <strong>%MEMBERCOUNT%</strong> of <strong>%CHANNELCOUNT%</strong> channels.";

// Retrieve the role description.
function showDescriptionToolTip(GroupName)
{
   var EncodedGroupName = encodeURIComponent(GroupName);

   var AJAXCommandName = "retrieve_group_description";
   var AJAXVariableGroupName = "GroupName=";

   $.ajax({url: AJAXCommandName, data: AJAXVariableGroupName + EncodedGroupName,
      async: false, 
      success: 
      function(data) 
      {                     
         try
         {
            var Response = eval(data);
 
            if(Response) 
            {
               var GroupTooltipMemberCountText = RawGroupTooltipMemberCountText.replace(/%MEMBERCOUNT%/g, Response.MemberCount);
               GroupTooltipMemberCountText = GroupTooltipMemberCountText.replace(/%CHANNELCOUNT%/g, Response.ChannelCount);

               var GroupTooltipDescriptionText = "";  
               if("" != Response.Description)
               {     
                  GroupTooltipDescriptionText = RawGroupTooltipDescriptionText.replace(/%DESCRIPTION%/g, Response.Description);
               } 

               TOOLtooltipLink(GroupTooltipDescriptionText + GroupTooltipMemberCountText, null, $("#channel_group_name_" + Response.GroupID)[0]);
            }
         }
         catch(err)
         {                             
         }        
      },

      error:
      function()
      {           
         MiniLogin.show('Iguana is not Responding', function() { showRoleDescriptionToolTip(GroupNameField); });
      }
   });
}

$(document).ready(function() 
{
   if("true" != $("#current_user_can_admin").val())
   {
      $("#disabled_add_channel_group_button").bind("mouseover", function(){ TOOLtooltipLink('You do not have the necessary permissions to add new channel groups.', null, this); } )
                                             .bind("mouseout", function(){ TOOLtooltipClose(); } )
                                             .bind("mouseup", function(){ TOOLtooltipClose(); } );
   }

   $("a.label").bind("mouseover", function(){ showDescriptionToolTip($(".group_name", this).val()) } )
               .bind("mouseout", function(){ TOOLtooltipClose(); } )
               .bind("click", function(){ TOOLtooltipClose(); } );

   $("li.channel_group_list_row").bind("mouseover", function(){ onRowEntered($(this)); } )
                            .bind("mouseout", function(){ onRowExited(); } );

   $("li.channel_group_list_row:nth-child(even)").removeClass("dark_row").addClass("light_row");

   $("a.channel_group_toggle").bind("click", function(){ onListViewToggle("channel_group_list_details_" + $(".group_id", this).val()); } );
 
   $("a.channel_group_remove").bind("click", function(){ remove_channel_group($(".channel_group_name", this).val()); } );

});
