<?cs include:"doctype.cs" ?>
<?cs include:"access_control_macros.cs" ?>

<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; Channel Groups &gt; <?cs if:groupName ?> <?cs var:html_escape(groupName) ?> <?cs else ?> New Group <?cs /if ?></title>
   <?cs include:"styles.cs" ?>

<link rel="stylesheet" type="text/css" href="jquery-ui/css/south-street/jquery-ui-1.7.2.custom.css" /> 
<link rel="stylesheet" type="text/css" href="/js/help_popup/help_popup.css" /> 

<script type="text/javascript" src="<?cs var:iguana_version_js("/js/ajax/ajax.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery132/jquery-1.3.2.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("/js/help_popup/help_popup.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("channel_filter.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("multi_select_chooser.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("resizable_textarea.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("ui.core.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("ui.draggable.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("ui.resizable.js") ?>"></script>
<script type="text/javascript" src="<?cs var:iguana_version_js("ui.dialog.js") ?>"></script>
<?cs include:"mini-login.cs" ?>

<script type="text/javascript"> <!--

var CGEmode = null;

function toggleMode()
{
   if (CGEmode == "view")
   {
      MSCsetMode("CGedit<?cs var:js_escape(groupName) ?>", "edit");
      CGEmode = "edit";
      document.getElementById("buttons").style.display="";
      document.getElementById("controlButtons").style.display="";
      document.getElementById("nameEdit").style.display="";
      document.getElementById("nameStatic").style.display="none";
      document.getElementById("descEdit").style.display="";
      document.getElementById("descStatic").style.display="none";
      document.getElementById("editButton").style.display="none";
      RTAresizeTimer(document.getElementById("groupDesc"));
   }
   else
   {
      //Not actually used (yet).  
      MSCsetMode("CGedit<?cs var:js_escape(groupName) ?>", "view");
      CGEmode = "view";

      document.getElementById("controlButtons").style.display="none";
      document.getElementById("descEdit").style.display="none";
      document.getElementById("buttons").style.display="none";
      document.getElementById("descStatic").style.display="";
      document.getElementById("editButton").style.display="";
   }
	
}

function filterTextChanged(Prefix)
{
   var Filter = document.getElementById(Prefix + "Filter");
   var ChannelSelector = document.getElementById("channel_" + Prefix);
   var ChannelCounter = document.getElementById("element_count_" + Prefix);
   var FilterSubmit = document.getElementById(Prefix + "FilterSubmit");
   FilterSubmit.value = Filter.value;
   var channelStringBuilder = [];
   var Options = ChannelSelector.getElementsByTagName("DIV");
   for ( var OptionsIndex = Options.length -1; OptionsIndex >= 0 ; --OptionsIndex )
   {

      channelStringBuilder.push(Options[OptionsIndex].id);
      channelStringBuilder.push(',');
   }
   //Drop the last comma.
   channelStringBuilder[channelStringBuilder.length -1] = "";
   filterChannels(Prefix, channelStringBuilder.join(''), Filter.value, ChannelSelector, ChannelCounter);

   manageClearIcon(Filter, Prefix);
	
}

function manageClearIcon(Filter, Prefix)
{
   var ClearIcon = document.getElementById(Prefix + "ImgClearFilterIcon");
   
   if(Filter.value == "")
   {
      ClearIcon.style.visibility = "hidden";
   }
   else
   {
      ClearIcon.style.visibility = "visible";
   }
}


function submitChannels()
{	
   var ChannelSelector = document.getElementById("channel_right");
   var invisibleChannelInput = document.getElementById("channelSubmit");
   var channelForm = document.getElementById("channel_form");
   var groupDesc = document.getElementById("groupDescSubmit");
   var NewNameSubmit = document.getElementById("groupNewName");
   var NewNameGather = document.getElementById("groupNameInput");

   NewNameSubmit.value = jQuery.trim(NewNameGather.value);

   groupDesc.value = document.getElementById("groupDesc").value;
   
   var channelStringBuilder = [];
   var Options = ChannelSelector.getElementsByTagName("DIV");
   for ( var OptionsIndex = Options.length -1; OptionsIndex >= 0 ; --OptionsIndex )
   {
      //Change to values (guid) later.
      channelStringBuilder.push(Options[OptionsIndex].id);
      channelStringBuilder.push(',');
   }
   channelStringBuilder[channelStringBuilder.length -1] = "";
   invisibleChannelInput.value = channelStringBuilder.join('');
   channelForm.submit();
}

function moveSelected(FromFix, ToFix, IsMoveAll)
{

   var From = document.getElementById("channel_" + FromFix);
  
   var FromOptions = From.getElementsByTagName("DIV");
   for ( var OptionsIndex = FromOptions.length -1; OptionsIndex >= 0 ; --OptionsIndex )
   {
      var Class = FromOptions[OptionsIndex].attributes.getNamedItem("class");	   
      if (IsMoveAll || ( Class && Class.value == "MSCselected") )
      {
	 if (FromOptions[OptionsIndex].style.display != "none")
	 { 
	 	MSCmove("CGedit<?cs var:js_escape(groupName) ?>", {"element":FromOptions[OptionsIndex]}, ToFix);
	 }
      }
   }

   filterTextChanged(ToFix);

}

function remove_channel(Channel)
{
   if( confirm('Remove channel "' + Channel + '" from this group?') )
   {
      document.remove_user.user.value = User;
      document.remove_user.submit();
   }
}

function set_focus()
{
}

function onLoad()
{
   MSCregister("CGedit<?cs var:js_escape(groupName) ?>", 
      document.getElementById("channel_left"), 
      document.getElementById("channel_right"), 
      200, 420); // resize calc excluded height, width
   MSCsetMode("CGedit<?cs var:js_escape(groupName) ?>", "view");
   CGEmode = "view";
   MSCresizeTimeout("CGedit<?cs var:js_escape(groupName) ?>");
   
   document.getElementById("groupDesc").value = "<?cs var:js_escape(groupDesc) ?>";
   
   window.onresize = function()
   { 
	   MSCresize("CGedit<?cs var:js_escape(groupName) ?>"); 
   };
   
   <?cs if: !groupName ?>
   toggleMode();
   <?cs /if ?>
   filterTextChanged("right");
   filterTextChanged("left");
   
   HLPpopUpinitialize(null);
}

--> </script>

</head>
<body class="tabright" onload="onLoad();" >

<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>

<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/advanced.html">Settings</a> &gt; <a href="/channel_groupings_view.html">Channel Groups</a> &gt;
               <?cs if:groupName ?>
                  <?cs var:html_escape(groupName) ?>
               <?cs else ?>
                  New Group
               <?cs /if ?>
         </td>
      </tr>

      <tr>
         <td id="dashboard_body">
            <center>
               <?cs if: StatusMessage ?>
			         <h3><font color="red"><?cs var:html_escape(StatusMessage) ?></font></h3>
	            <?cs /if ?>
                  <table class="configuration" style="border-collapse:separate">
                     <tr>
                        <th colspan="3">GROUP DETAILS</th>
                     </tr>
		     <tr>

		        <td class ="left_column">Name</td>
			<td colspan = "2">
			<div id="nameEdit" style="display:none">
      			<input style="width:439px" name="groupNameInput" id="groupNameInput" value="<?cs var:html_escape(groupName) ?>" maxlength="30"/>
			</div>
			<div id="nameStatic">
			<span><?cs var:html_escape(groupName) ?></span>
			</div>
			</td>		
		     </tr>
		     <tr>
			<td class ="left_column">Description</td>
			<td colspan = "2">
			<div id="descEdit" style="display:none">
      			<textarea name="groupDesc" id="groupDesc" onkeyup="javascript:RTAresizeTimer(this)" style="width:95%; overflow:hidden"><?cs var:html_escape(groupDesc) ?></textarea>
			</div>
			<div id="descStatic">
                        <span><?cs var:newline_html(html_escape(groupDesc)) ?></span>
			</div>
			</td>
		     </tr>
		     <tr><td class="left_column">Grouping</td>
		     <td>
		     <table>
		     <tr>
		        <td class="left_column" style="color:#333333;padding-top:8px;padding-bottom:5px;"><center>Channels not in group</center></td>
			<td></td>
			<td class="left_column" style="color:#333333;padding-top:8px;padding-bottom:5px;"><center>Channels in group</center></td>
		     </tr>
                        <tr>
                           <td>
			   <table><tr><td>
                              <div id="channel_left" name="channel_left" class="custom_multi_select" style="border-bottom:none;">
			         <?cs each: channel = Channels ?>
                                    <?cs if !channel.InGroup ?>   
                                       <div id="<?cs var:html_escape(channel.Value) ?>" class="MSCunselected" onclick="MSCtoggle('CGedit<?cs var:html_escape(js_escape(groupName)) ?>', '<?cs var:html_escape(channel.Value) ?>');" ondblclick="MSCmove('CGedit<?cs var:html_escape(js_escape(groupName)) ?>', {'id':'<?cs var:html_escape(channel.Value) ?>'}, 'right');filterTextChanged('right');" value="<?cs var:html_escape(channel.Name) ?>"><?cs var:html_escape(channel.Name) ?></div>
				    <?cs /if ?>
                                 <?cs /each ?>
                              </div>
                              <div style="border: 1px solid #BBBBBB; border-top:none; padding:4px; background:#e0e0e0; text-align:center;">
			   					<span id="element_count_left" style="color:#4c4c4c;"></span>
			   				</div>
			   </td></tr>
			   <tr><td>

			   </td></tr></table>
			   
                           </td>
			   <td style="width:44px;"><center>
			   <div id="controlButtons" style="display:none;">
			   <table><tr><td>
			   <a class="button" onClick="moveSelected('left', 'right', false);"
			   	    onMouseOver="TOOLtooltipLink('Move selected.', null, this);"
                                    onMouseOut="TOOLtooltipClose();"
                                    onmouseup="TOOLtooltipClose();" style="width:23px;"><span>
                                    <img src="/images/arrow_right_one.gif" alt=""/>
                           </span></a></td></tr>
			   <tr>
			   <td/><a class="button" onClick="moveSelected('right', 'left', false);"
  			            onMouseOver="TOOLtooltipLink('Move selected.', null, this);"
                                    onMouseOut="TOOLtooltipClose();"
                                    onmouseup="TOOLtooltipClose();" style="width:23px;"><span>
                                    <img src="/images/arrow_left_one.gif" alt=""/>
                           </span></a></td>
                           </tr>
			   <tr>
			   <td>			   
			   <a class="button" onClick="moveSelected('left', 'right', true);" 
			            onMouseOver="TOOLtooltipLink('Move all.', null, this);"
                                    onMouseOut="TOOLtooltipClose();"
                                    onmouseup="TOOLtooltipClose();" style="width:23px;"><span>
                                    <img src="/images/arrow_right_all.gif" alt=""/>
                           </span></a></td></tr>
			   <tr>
			   <td><a class="button" onClick="moveSelected('right', 'left', true);"
   			            onMouseOver="TOOLtooltipLink('Move all.', null, this);"
                                    onMouseOut="TOOLtooltipClose();"
                                    onmouseup="TOOLtooltipClose();" style="width:23px;"><span>
                                    <img src="/images/arrow_left_all.gif" alt=""/>
				</span></a></td>
                           </tr>
			   </table>
			   </div>
			      <form id="channel_form" method="get" action="/channel_grouping_edit.html" >
        			 <input type="hidden" name="action" value="<?cs if groupName ?>save<?cs else ?>createGroup<?cs /if ?>"/>
                     <input type="hidden" name="groupName" value="<?cs var: html_escape(groupName) ?>"/>
				     <input type="hidden" id="groupNewName" name="groupNewName" value="<?cs var: html_escape(groupName) ?>"/>
				     <input type="hidden" id="channelSubmit" name="channelSubmit"/>
                     <input type="hidden" id="rightFilterSubmit" name="rightFilterSubmit"  value="<?cs var: html_escape(rightFilterSubmit) ?>"/>
                     <input type="hidden" id="leftFilterSubmit" name="leftFilterSubmit" value="<?cs var: html_escape(leftFilterSubmit) ?>"/>
 			         <input type="hidden" id="groupDescSubmit" name="groupDesc" value="<?cs var: html_escape(groupDesc) ?>"/>
      			       </form>
			   </center>
			   </td>
                           <td>
			   <table><tr><td>
			      <div id="channel_right" name="channel_right" class="custom_multi_select" style="border-bottom:none;">
			         <?cs each: channel = Channels ?>
                                    <?cs if channel.InGroup ?>   
                                       <div id="<?cs var:html_escape(channel.Value) ?>" class="MSCunselected" onclick="MSCtoggle('CGedit<?cs var:html_escape(js_escape(groupName)) ?>', '<?cs var:js_escape(channel.Value) ?>');" ondblclick="MSCmove('CGedit<?cs var:html_escape(js_escape(groupName)) ?>', {'id':'<?cs var:js_escape(channel.Value) ?>'}, 'left');filterTextChanged('left');" value="<?cs var:html_escape(channel.Name) ?>"><?cs var:html_escape(channel.Name) ?></div>
				    <?cs /if ?>
                                 <?cs /each ?>
                              </div>
                              <div style="border: 1px solid #BBBBBB; border-top:none; padding:4px; background:#e0e0e0; text-align:center;">
                              <span id="element_count_right" style="color:#4c4c4c;"></span>
                              </div>
			      </td></tr>
			      <tr><td>

			      </td></tr></table>
                           </td>
                        </tr>
                        <tr><td><center>
                        
<table style="margin-top:-5px;margin-bottom:10px;"><tr><td>                    
			<table class="filter_field_container"><tr>
                           <td style="padding-left:0px; padding-top:0px; padding-bottom:0px;">	
			      <div class="filter_field">
					<img name="imgMagnifyingGlass" src="/images/icon_search.gif" alt=""/>
					<input id="leftFilter" value="<?cs var: html_escape(leftFilterSubmit) ?>"
						onchange="filterTextChanged('left');" 
						onkeyup="filterTextChanged('left');"
						onmouseover="MSCshowSearchTooltip(this);"
			                        onmouseout="MSChideSearchTooltip();"
	                		        onmouseup="MSChideSearchTooltip();"
						/>
					<a onclick="javascript:document.getElementById('leftFilter').value='';filterTextChanged('left');">
					   <img id="leftImgClearFilterIcon" name="imgClearFilterIcon" alt="" src="/<?cs var:skin("images/ex14.gif") ?>"/>
					</a>
				</div>
			   </td>
			   <td>
                  <a id="left_group_TextQuery_Icon" class="helpIcon" tabindex="100" title="More Information" target="_blank" href="#" onclick="return false;"
   rel="Use the Search field to display only the channels whose name or description matches what you type in the field.
			<p>In this field, you can specify multiple words to be matched, exclude words, or use regular expressions.</p>
			<p>For example, the search</p>
		       <p><strong>animal NOT (dog OR cat) -kitten /me+ow/</strong></p>
		       <p>matches all channel names that contain <strong>animal</strong>, do not contain <strong>dog</strong>, <strong>cat</strong> or <strong>kitten</strong>,
			and contain <strong>m</strong> followed by one or more of <strong>e</strong> followed by <strong>ow</strong>
			(for example, <strong>meow</strong>, <strong>meeow</strong> and <strong>meeeow</strong>).</p>
                             <a href=&quot;http://www.interfaceware.com/manual/iguana4_dashboard_search_criteria.html&quot; target=&quot;_blank&quot;>Learn More About Specifying Search Criteria In A Dashboard Search</a></br>">
                     <img src="<?cs var:skin("/images/help_icon.gif") ?>" border="0" />
                  </a>
               </td>			   	   
			   </tr>
			</table>

</td></tr></table>		
</center>			
			
			   </td><td>&nbsp</td><td><center>
                        
<table style="margin-top:-5px;margin-bottom:10px;"><tr><td> 			   
			<table class="filter_field_container"><tr>
                           <td style="padding-left:0px; padding-top:0px; padding-bottom:0px;">	
			      <div class="filter_field">
					<img name="imgMagnifyingGlass" src="/images/icon_search.gif" alt=""/>
					<input id="rightFilter"  value="<?cs var: html_escape(rightFilterSubmit) ?>"
						onchange="filterTextChanged('right');"
						onkeyup="filterTextChanged('right');"
						onmouseover="MSCshowSearchTooltip(this);"
			                        onmouseout="MSChideSearchTooltip();"
	                		        onmouseup="MSChideSearchTooltip();"
						/>
					<a onclick="javascript:document.getElementById('rightFilter').value='';filterTextChanged('right');">
					   <img id="rightImgClearFilterIcon" name="imgClearFilterIcon" alt="" src="/<?cs var:skin("images/ex14.gif") ?>"/>
					</a>
				</div>
			   </td>
			   <td>
                  <a id="right_group_TextQuery_Icon" class="helpIcon" tabindex="100" title="More Information" target="_blank" href="#" onclick="return false;"
   rel="Use the Search field to display only the channels whose name or description matches what you type in the field.
			<p>In this field, you can specify multiple words to be matched, exclude words, or use regular expressions.</p>
			<p>For example, the search</p>
		       <p><strong>animal NOT (dog OR cat) -kitten /me+ow/</strong></p>
		       <p>matches all channel names that contain <strong>animal</strong>, do not contain <strong>dog</strong>, <strong>cat</strong> or <strong>kitten</strong>,
			and contain <strong>m</strong> followed by one or more of <strong>e</strong> followed by <strong>ow</strong>
			(for example, <strong>meow</strong>, <strong>meeow</strong> and <strong>meeeow</strong>).</p>
                             <a href=&quot;http://www.interfaceware.com/manual/iguana4_dashboard_search_criteria.html&quot; target=&quot;_blank&quot;>Learn More About Specifying Search Criteria In A Dashboard Search</a></br>">
                     <img src="<?cs var:skin("/images/help_icon.gif") ?>" border="0" />
                  </a>
               </td>			   
			   
			   
			   </tr>
			</table>
</td></tr></table>
</center>

			   </td></tr>
			   </table></td></tr>
                  </table>
                  
                  
               <br />

			   <table id="editButton" <?cs if:!groupName ?>style="display:none"<?cs /if ?>>
			   <tr><td>
                              <?cs if:CurrentUserCanAdmin ?>
                                 <a class="button" href="javascript:toggleMode();"><span>
                                    <img src="../<?cs var:skin("images/icon_edit.gif") ?>" /> &nbsp;Edit
                                 </span></a>
                              <?cs else ?>
                                 <div class="button_disable"
                                    onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);"
                                    onMouseOut="TOOLtooltipClose();"
                                    onmouseup="TOOLtooltipClose();" >
                                    <span>
                                       <img src="../<?cs var:skin("images/icon_edit_disable.gif") ?>" /> &nbsp;Edit
                                    </span>
                                 </div>
                              <?cs /if ?>
			      </td></tr>
			   </table>
	       
               <table id="buttons" <?cs if:groupName ?>style="display:none"<?cs /if ?>><tr>
                  <?cs if:groupName ?>
		       <?cs if:CurrentUserCanAdmin ?>
                              <td id="tdApplyChanges">
                                 <a class="button" href="javascript:submitChannels();"><span><img src='../<?cs var:skin("images/icon_save.gif") ?>' /> &nbsp;Save Changes</span></a>
                              </td>
                              <td>
                                 <a class="button" href="/channel_grouping_edit.html?groupName=<?cs var:html_escape(url_escape(groupName)) ?>"><span>Cancel</span></a>
                              </td>
                        <?cs /if ?>		   
                  <?cs else ?>
		               <?cs if:CurrentUserCanAdmin ?>
                        <td>
                           <a class="button" href="javascript:submitChannels();"><span><img src="../<?cs var:skin("images/icon_save.gif") ?>" /> &nbsp;Add Group</span></a>
                        </td>
                        <td>
                           <a class="button" href="/channel_groupings_view.html"><span>Cancel</span></a>
                        </td>
                     <?cs /if ?>
                  <?cs /if ?>
               </tr></table>
	    </div>
            </center>
         </td>
      </tr>
   </table>

      <div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
            <?cs if:Group.Name ?>
               <p>
                  On this page, you can add channels to a channel grouping.
               </p> 
            <?cs else ?>
            <p>
               Use this page to add a new channel grouping to this Iguana server.
            </p>
            <?cs /if ?>
            <h4 class="side_title">Related Settings</h4>
            <a href="/email_status.html">Email Notification</a>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
                  <?cs if:groupName ?>
               <li>
               <a href="http://www.interfaceware.com/manual/iguana4_channel_groups_adding_deleting.html" target="_blank">Adding or Deleting Channels in a Group</a>
               </li>
               <li>
               <a href="http://www.interfaceware.com/manual/iguana4_channel_groups_searching.html" target="_blank">Searching in a Channel Group</a>
               </li>
                 <?cs else ?>
               <li>
               <a href="http://www.interfaceware.com/manual/iguana4_channel_groups_creating.html" target="_blank">Creating a Channel Group</a>
               </li>
                  <?cs /if ?>
            </ul>
         </td>
      </tr>
   </table>
   </div>

	 <div id="helpTooltipDiv" class="helpTooltip">
	 	    <b id="helpTooltipTitle"></b>
	 	    <em id="helpTooltipBody"></em>
	 	    <input type="hidden" name="helpTooltipId" id="helpTooltipId" value="0">
	 	 </div>

</body>
</html>

