<?cs include:"doctype.cs" ?>

<html>
<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Dashboard &gt; Channel Properties</title>
   <?cs include:"styles.cs" ?>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery132/jquery-1.3.2.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.core.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.draggable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.resizable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.dialog.js") ?>"></script>
   <link rel="stylesheet" type="text/css" href="jquery-ui/css/south-street/jquery-ui-1.7.2.custom.css" />
<style  type="text/css">
   
   #divChannelList
   {
      overflow-y: auto;
      overflow-x: hidden;
   }
   
   div.floating_heading
   {
      position: absolute;
      background-color: #FFFFFF;
      overflow: hidden;
   }
   
   .inner_scrollable_table
   {
      width: 100%;
   }
   
   .hidden_heading
   {
      visibility: hidden;
   }
   
   select.heading_select
   {
      margin-top: 3px;
      color: gray;
      text-transform: none;
      letter-spacing: 0.0em;
   }
   
   option.gray
   {
      color: gray;
   }
   
   option.black
   {
      color: black;
   }

</style>
   
<script type="text/javascript">

   function updateAllEmailNotificationFlags(checkbox)
   {
      <?cs each:channel = Channels ?>
      document.getElementById("inputEmailEnabled.<?cs var: name(channel) ?>").checked = checkbox.checked;
      <?cs /each ?>
   }
   
   function updateAllStartAutomaticallyFlags(checkbox)
   {
      <?cs each:channel = Channels ?>
      if(!document.getElementById("inputStartAutomatically.<?cs var: name(channel) ?>").disabled)
      {
         document.getElementById("inputStartAutomatically.<?cs var: name(channel) ?>").checked = checkbox.checked;
      }
      <?cs /each ?>
   }
   
   function updateAllLoggingLevelValues(select)
   {
      var MasterSelect = document.getElementById("LoggingLevelMasterValue");
      var MasterValue = MasterSelect.value;
      
      // Delete the "Change all..." option
      if (document.getElementById("optionChangeAll"))
      {
         MasterSelect.removeChild(document.getElementById("optionChangeAll"));
         MasterSelect.style.color = "black";
      }
      <?cs each:channel = Channels ?>
      if(document.getElementById("selectLoggingLevel.<?cs var: name(channel) ?>"))
      {
         document.getElementById("selectLoggingLevel.<?cs var: name(channel) ?>").value = MasterValue;
      }
      <?cs /each ?>
      
      // In IE6, deleting the "Change all..." option will change the current selection.
      MasterSelect.value = MasterValue;
   }
   
   function truncate(Text)
   {
      if (Text.length > 30)
      {
         Text = Text.substr(0, 27) + '...';
      }
      return Text;
   }
   
   var resizeTimeoutId;
   
   // This function is for a bug in IE6 where <select> elements overlap everything else,
   // no matter what the z-indexes of elements are.
   // We may want to execute this function in IE6 only, since for other browsers
   // it is not necessary.
   function hideDropDowns()
   {
      var FirstRow = document.getElementById("tr.0");
      if (FirstRow)
      {
         // Find the table border width
         var HiddenHeading = document.getElementById("thHiddenLoggingLevel");
         var BottomOfHeading = HiddenHeading.offsetTop + HiddenHeading.clientHeight;
         var BorderWidth = FirstRow.offsetTop - BottomOfHeading;
         
         // Find the offset top of the drop down menu
         var DropDownTop = document.getElementById("selectLoggingLevel.0").offsetTop;
         
         // Find the row height
         var RowHeight = FirstRow.clientHeight + BorderWidth;
         
         // Define the cutoff for making the drop down menus invisible
         var DropDownCutoffLine = document.getElementById("divChannelList").scrollTop - DropDownTop - BorderWidth;
         
         // Find the index of the first channel row in which the drop down menu should be visible
         var FirstVisibleChannelIndex = DropDownCutoffLine / RowHeight;
         
         // Make necessary drop down menus invisible
         <?cs each:channel = Channels ?>
         if (<?cs var: name(channel) ?> < FirstVisibleChannelIndex)
         {
            document.getElementById("selectLoggingLevel.<?cs var: name(channel) ?>").style.visibility = 'hidden';
         }
         else
         {
            document.getElementById("selectLoggingLevel.<?cs var: name(channel) ?>").style.visibility = 'visible';
         }
         <?cs /each ?>
      }
   }
   
   function onResize()
   {
      // Some browsers (like firefox) don't always call onResize() at the right time.
      // So we will make sure to run the adjustments the user's mouse stops moving.
      clearTimeout(resizeTimeoutId);
      resizeTimeoutId = setTimeout("adjustTableDimensions();", 150);
   }
   
   function widthWithPadding(Element)
   {
      return Element.clientWidth - parseInt(WINgetStyle(Element, 'paddingLeft')) - parseInt(WINgetStyle(Element, 'paddingRight'));
   }
   
   function adjustTableDimensions()
   {
      var ChannelListDiv = document.getElementById('divChannelList');
      var TableData = document.getElementById('tableData');
      var FloatingHeadings = document.getElementById('floatingHeadings');
      var TableHeadings = document.getElementById('tableHeadings');
   
   
      // Table height - fit size to screen
      var NewHeight = (WINgetWindowHeight() - WINwindowOffsetTop(ChannelListDiv)) - 95;
      if (NewHeight < 75)
      {
         NewHeight = 75;
      }
      ChannelListDiv.style.height = NewHeight + 'px';
      
      
      // Table width - set explicitly to adjust for scrollbars in Internet Explorer
      TableData.style.width = '0px'; // This will set ChannelListDiv's width to what it should be, without being influenced by TableData's width
      TableData.style.width = ChannelListDiv.clientWidth + 'px';
      
      
      // Column widths - match the floating heading's columns with the data table's
      var ChannelNameHeader = document.getElementById('thChannelName');
      var StartAutomaticallyHeader = document.getElementById('thStartAutomatically');
      var LoggingLevelHeader = document.getElementById('thLoggingLevel');
      var HiddenChannelNameHeader = document.getElementById('thHiddenChannelName');
      var HiddenStartAutomaticallyHeader = document.getElementById('thHiddenStartAutomatically');
      var HiddenLoggingLevelHeader = document.getElementById('thHiddenLoggingLevel');
      
      ChannelNameHeader.style.width = widthWithPadding(HiddenChannelNameHeader) + 'px';
      StartAutomaticallyHeader.style.width = widthWithPadding(HiddenStartAutomaticallyHeader) + 'px';
      LoggingLevelHeader.style.width = widthWithPadding(HiddenLoggingLevelHeader) + 'px';
      
      
      // Table heading width - chop off extra headings (only needed for firefox)
      TableHeadings.style.width = TableData.clientWidth + 'px';
      FloatingHeadings.style.width = ChannelListDiv.clientWidth + 'px';

   }
   
   function onLoad()
   {
      adjustTableDimensions();
   
      window.onresize = onResize;
      onResize();    
   }

</script>

</head>

<body class="tableft" onload="onLoad();">

<?cs set:Navigation.CurrentTab = "Dashboard" ?>
<?cs include:"header.cs" ?>


<div id="main">


   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/dashboard.html">Dashboard</a> &gt; Channel Properties
         </td>
      </tr>

   <tr>
      <td id="dashboard_body">
         
         <?cs if:CountOfChannel == 0 ?>
            <p style="text-align: center;">
               No channels have been created. Use the <a href="/dashboard.html">dashboard</a> to add a channel.
            </p>
         <?cs else ?>
         
            <?cs if:SettingsUpdated == "true" ?>
            <p style="text-align:center; color:green; font-weight:bold;">
               Changes have been saved.
            </p>
            <?cs /if ?>
         
            <form name="ChannelProperties" method="post" action"/channel_properties.html">
            <div style="text-align: left;">
            
               <div id="floatingHeadings" class="floating_heading">
                  <table id="tableHeadings">
                     <tr>
                        <th id="thChannelName">Channel</th>
                        <th id="thStartAutomatically">
                           Start Automatically<br />
                           <input type="checkbox" class="no_style" id="StartAutomaticallyMasterFlag"
                              onclick="updateAllStartAutomaticallyFlags(this);"
                              <?cs if:!CurrentUserCanReconfigureSome ?>disabled<?cs /if ?>
                              <?cs set:allStartAutomaticallyFlagsEnabled = "true" ?>
                              <?cs each:channel = Channels ?>
                              <?cs if:!channel.IsStartAutomaticallyEnabled ?>
                                 <?cs set:allStartAutomaticallyFlagsEnabled = "false" ?>
                              <?cs /if ?>
                              <?cs /each ?>
                              <?cs if:allStartAutomaticallyFlagsEnabled == "true" ?>checked<?cs /if ?>
                              />
                        </th>
                        <th id="thLoggingLevel">
                           Logging Level<br />
                           <select id="LoggingLevelMasterValue"
                              class="heading_select"
                              onchange="updateAllLoggingLevelValues(this);"
                              <?cs if:!CurrentUserCanReconfigureSome ?>disabled<?cs /if ?> >
                              <option class="gray" id="optionChangeAll" value="-1">Change all...</option>
                              <?cs each:loggingLevel = LoggingLevels ?>
                                 <option class="black" value="<?cs name:loggingLevel ?>">
                                    <?cs var:loggingLevel ?>
                                 </option>
                              <?cs /each ?>
                           </select>
                        </th>
                     </tr>
                  </table>
               </div>
               
               <div id="divChannelList" onscroll="hideDropDowns();">
                  <table id="tableData" class="inner_scrollable_table">
                  
                     <!-- It is important that this row of headings have the same contents as the visible row above, so their sizes match -->
                     <tr class="hidden_heading">
                        <th id="thHiddenChannelName" class="hidden_heading">Channel</th>
                        <th id="thHiddenStartAutomatically" class="hidden_heading">
                           Start Automatically<br />
                           <input type="checkbox" class="no_style" id="StartAutomaticallyMasterFlag" />
                        </th>
                        <th id="thHiddenLoggingLevel">
                           Logging Level<br />
                           <select class="heading_select" >
                              <option value="-1">Change all...</option>
                              <?cs each:loggingLevel = LoggingLevels ?>
                                 <option><?cs var:loggingLevel ?></option>
                              <?cs /each ?>
                           </select>
                        </th>
                     </tr>
                  
                     <?cs each:channel = Channels ?>
                        <?cs if: name(channel) % 2 ?>
                        <tr id="tr.<?cs var: name(channel) ?>" class="second">  <?cs else ?>  <tr id="tr.<?cs var: name(channel) ?>" class="first">
                        <?cs /if ?>
                           <td id="tdChannelName.<?cs name:channel ?>" class="left" style="white-space: nowrap;">
                              <a href="/channel.html?Channel=<?cs var:url_escape(channel.Name) ?>">
                                 <script type="text/javascript">
                                    var ChannelName = truncate('<?cs var:js_escape(channel.Name) ?>');
                                    ChannelName = ChannelName.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g,"&gt;");
                                    document.write(ChannelName);
                                 </script>
                              </a>
                              <?cs if: channel.IsRunning ?>&nbsp(running)<?cs /if ?>
                           </td>
                           <td class="center">
                              <input type="checkbox" class="no_style" id="inputStartAutomatically.<?cs var: name(channel) ?>" name="<?cs var: html_escape(channel.Name) ?>.EnableStartAutomatically"
                                 <?cs if:!channel.CanReconfigure ?>disabled<?cs /if ?>
                                 <?cs if:channel.IsStartAutomaticallyEnabled ?>checked<?cs /if ?> />
                           </td>
                           <td class="center">
                              <?cs if:channel.CanReconfigure ?>
                                 <select id="selectLoggingLevel.<?cs var: name(channel) ?>" name="<?cs var: html_escape(channel.Name) ?>.LoggingLevel"
                                 <?cs each:loggingLevel = LoggingLevels ?>
                                    <option value="<?cs name:loggingLevel ?>" <?cs if:name(loggingLevel) == channel.LoggingLevel ?>selected<?cs /if ?>>
                                       <?cs var:loggingLevel ?>
                                    </option>
                                 <?cs /each ?>
                                 </select>
                              <?cs else ?>
                                 <?cs each:loggingLevel = LoggingLevels ?>
                                    <?cs if:name(loggingLevel) == channel.LoggingLevel ?><?cs var:loggingLevel ?><?cs /if ?>
                                 <?cs /each ?>
                              <?cs /if ?>
                           </td>
                        </tr>
                     <?cs /each ?>
                  </table>
               </div>
               
               <input type="hidden" name="Action" value="Apply Changes" />
                  
            </div>
            </form>
               
            <p/><p/>
            
            <center>
            
               
               <table id="buttons"><tr>
                  <td>
                     <?cs if:CurrentUserCanReconfigureSome ?>
                        <a class="button" href="javascript:document.ChannelProperties.submit();"><span><img src="../<?cs var:skin("images/icon_save.gif") ?>" /> &nbsp;Save Changes</span></a>
                     <?cs else ?>
                        <div class="button_disable" id="DisabledEditButton" onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);" onMouseOut="TOOLtooltipClose();" onmouseup="TOOLtooltipClose();" ><span><img src="../<?cs var:skin("images/icon_save_disable.gif") ?>" /> &nbsp;Save Changes</span></div>
                     <?cs /if ?>
                  </td>
               </tr></table>
               
               
            
            </center>
            
         <?cs /if ?>
         
      </td>
   </tr>
   </table>

</div>


<div id="side_panel">

   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
            <p>
               On this page, you can set some of the most commonly used channel properties.
            </p>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
            	<li>
            	<a href="http://www.interfaceware.com/manual/iguana4_channel_properties.html" target="_blank">Displaying Channel Properties</a>
            	</li>
            </ul>
         </td>
      </tr>
   </table>

</div>



</body>

</html>
