<?cs # vim: set syntax=html :?>

<?cs include:"browse_macro.cs" ?>

<script defer type="text/javascript"> <!--

function toggleNumberOfReconnectsTextField()
{
   var ReconnectOptionsComboBox = document.channel_data.DstMaxReconnectsChoiceBox;
   var ReconnectsText = document.getElementById('DstMaxReconnectsText');
   var ReconnectIntervalRow = document.getElementById('DstReconnectIntervalRow');
   
   if(ReconnectOptionsComboBox.options[ReconnectOptionsComboBox.selectedIndex].value == "other")
   {
      ReconnectsText.style.display="";
   }
   else
   {
      ReconnectsText.style.display="none";
   }
   if(ReconnectOptionsComboBox.options[ReconnectOptionsComboBox.selectedIndex].value != "never")
   {
      ReconnectIntervalRow.style.display = "";
   }
   else
   {
      ReconnectIntervalRow.style.display = "none";
   }   
}

function onLoadToDatabase()
{
   showDatabaseNote('Dst', document.channel_data.DstDatabaseApi.value);
}

--> </script>

<?cs with: dest = Channel.Destination ?>
   <?cs def:database_settings(ComponentDatabase, ComponentError) ?>
      <?cs set:ComponentType = "Dst" ?> 
      <?cs include: "component_database.cs" ?>
   <?cs /def ?>
   <?cs call:database_settings(dest.Database, Consumer.Error) ?>

   <script defer type="text/javascript">
      //Doesn't work in onLoadToDatabase
      //Put it here, after the component_database.cs include.
      DstupdateDatasourcePreview();
      DstupdateDatauserPreview();
      setInterval("DstupdateDatasourcePreview(); DstupdateDatauserPreview();", 500);
   </script>
   
   <tr class="selected">
      <td class="left_column">On database error</td>
      <td class="inner_left" colspan="3">
         <?cs if:Channel.ReadOnlyMode ?>
           <?cs if:dest.ActionOnDbError == "skip" ?>
	      Skip message
	   <?cs elif:dest.ActionOnDbError == "stop" ?>
	      Stop channel
	   <?cs else ?>
              Unknown
	   <?cs /if ?>
	 <?cs else ?>
	   <input type="radio" name="DstActionOnDbError" value="skip" <?cs if:dest.ActionOnDbError == "skip" ?>checked<?cs /if ?> >Skip message</input>
	   <br><input type="radio" name="DstActionOnDbError" value="stop" <?cs if:dest.ActionOnDbError == "stop" ?>checked<?cs /if ?> >Stop channel</input>
	 <?cs /if ?>
      </td>
   </tr>


   <tr class="selected">
      <td class="left_column">Full parser VMD path<font color="#ff0000">*</font></td>
      <td class="inner_left" colspan="3">
         <?cs if:Channel.ReadOnlyMode ?>
            <?cs call:browse_readonly(dest.ParserVmdPath) ?>
               <?cs if:Consumer.Error.ParserVmdPath ?>
               <div class="configuration_error">
	          <?cs var:Consumer.Error.ParserVmdPath ?>
	       </div>
	    <?cs /if ?>
	 <?cs else ?>
	    <?cs call:browse_input('DstParserVmdPath', dest.ParserVmdPath) ?>
	 <?cs /if ?>
     </td>
   </tr>

   <tr class="selected">
      <td class="left_column">On VMD parse error</td>
      <td class="inner_left" colspan="3">
         <?cs if:Channel.ReadOnlyMode ?>
            <?cs if:dest.ActionOnParseError == "skip" ?>
               Skip message
            <?cs elif:dest.ActionOnParseError == "stop" ?>
               Stop channel
            <?cs else ?>
               Unknown
            <?cs /if ?>
         <?cs else ?>
            <input type="radio" name="DstActionOnParseError" value="skip" <?cs if:dest.ActionOnParseError == "skip" ?>checked<?cs /if ?> >Skip message</input>
            <br><input type="radio" name="DstActionOnParseError" value="stop" <?cs if:dest.ActionOnParseError == "stop" ?>checked<?cs /if ?> >Stop channel</input>
         <?cs /if ?>
      </td>
   </tr>

   <tr class="selected">
      <td class="left_column">Data insertion order</td>
      <td class="inner_left" colspan="3">
         <?cs if:!Channel.ReadOnlyMode ?>
            <input type="radio" name="DstInsertSorted" value=""
               <?cs if:!dest.InsertSorted ?>checked<?cs /if ?> >In table grammar order
            <br>
            <input type="radio" name="DstInsertSorted" value="on"
               <?cs if: dest.InsertSorted ?>checked<?cs /if ?> >In alphabetical order by table name
            <a id="DstInsertSorted_Icon" class="helpIcon" tabindex="100"
               rel="In rare circumstances deadlocks can occur if two or more 
                    channels insert data into the same tables, but in
                    different orders.  Order is normally dictated by each
                    message's table grammar.  Here you can force insertions
                    and updates to be done alphabetically by table name."
               title="More Information" href="#"
               ><img src="<?cs var:skin("/images/help_icon.gif") ?>" border="0" /></a> 
         <?cs elif:dest.InsertSorted ?>
            In alphabetical order by table name
         <?cs else ?>
            In table grammar order
         <?cs /if ?>
      </td>
   </tr>

   <tr class="selected" id="DstReconnectToDbRow">
      <td class="left_column">Reconnect to DB?</td>
      <td class="inner_left" colspan="3">
         <?cs if:Channel.ReadOnlyMode ?>
            <?cs if:dest.MaxReconnects == 0 && dest.UnlimitedMaxReconnects == 0 ?>No
            <?cs elif:dest.UnlimitedMaxReconnects != 0?>Yes <span class="configurationFillerText">(unlimited)</span>
            <?cs elif:dest.MaxReconnects > 0 && dest.UnlimitedMaxReconnects == 0 ?>Yes<span class="configurationFillerText">, with limit of</span><?cs /if ?>
         <?cs else ?>
            <select name="DstMaxReconnectsChoiceBox" onchange="toggleNumberOfReconnectsTextField();" onkeyup="toggleNumberOfReconnectsTextField();">
               <option value="never" <?cs if:dest.MaxReconnects == 0 ?>selected="selected"<?cs /if ?> >No</option>
               <option value="unlimited" <?cs if:dest.UnlimitedMaxReconnects != 0?>selected="selected"<?cs /if ?> >Yes (unlimited)</option>
               <option value="other"  <?cs if:dest.MaxReconnects > 0 && dest.UnlimitedMaxReconnects == 0 ?>selected="selected"<?cs /if ?>>Yes, with limit</option>
            </select>
         <?cs /if ?>
         <span id="DstMaxReconnectsText" style="font-size: 11px;<?cs if:dest.UnlimitedMaxReconnects != 0 || dest.MaxReconnects == 0 ?> display: none;<?cs /if ?>" >
            <?cs if:Channel.ReadOnlyMode ?>
               <?cs var:html_escape(dest.MaxReconnects) ?> times
            <?cs else ?>
               of&nbsp;
               <input class="configuration_smaller" name="DstMaxReconnects" id="DstMaxReconnectsInput"
                  value="<?cs if:dest.MaxReconnects == 0 ?>10<?cs else ?><?cs var:dest.MaxReconnects ?><?cs /if ?>" />
               &nbsp;times
               <span id="DstMaxReconnectsErrorMessageContainer" class="validation_error_message_container"></span>
               <script defer type="text/javascript">
                  VALregisterIntegerValidationFunction
                  (
                     'DstMaxReconnectsInput', 'DstReconnectToDbRow', 'DstMaxReconnectsErrorMessageContainer',
                     function()
                     {
                        var ReconnectOptionsComboBox = document.channel_data.DstMaxReconnectsChoiceBox;
                        return ReconnectOptionsComboBox.options[ReconnectOptionsComboBox.selectedIndex].value == "other";
                     },
                     showDestinationTab
                  );
               </script>
            <?cs /if ?>
         </span>         
      </td>
   </tr>
   
   <tr class="selected" id="DstReconnectIntervalRow"<?cs if:dest.MaxReconnects == 0 && dest.UnlimitedMaxReconnects == 0 ?> style="display:none;"<?cs /if ?>>
      <td class="left_column">Reconnection interval<font color="#ff0000">*</font></td>
      <td class="inner_left" colspan="3">
                  
         <?cs if:Channel.ReadOnlyMode ?>
            <?cs var:html_escape(dest.ReconnectInterval) ?>
         <?cs else ?>
            <input class="configuration_smaller" name="DstReconnectInterval" id="DstReconnectIntervalInput"
               value="<?cs var:dest.ReconnectInterval ?>">
            <script defer type="text/javascript">
               VALregisterIntegerValidationFunction
               (
                  'DstReconnectIntervalInput', 'DstReconnectIntervalRow', 'DstReconnectIntervalErrorMessageContainer',
                  function()
                  {
                     var ReconnectOptionsComboBox = document.channel_data.DstMaxReconnectsChoiceBox;
                     return ReconnectOptionsComboBox.options[ReconnectOptionsComboBox.selectedIndex].value != "never";
                  },
                  showDestinationTab
               );
            </script>
         <?cs /if ?>
         &nbsp;milliseconds
         <span id="DstReconnectIntervalErrorMessageContainer" class="validation_error_message_container"></span>

      </td>
   </tr>

   <tr class="selected" id="RowDestTimeout"
      <?cs if:Channel.ReadOnlyMode && dest.Database.Type != "ODBC - MS SQL Server" ?>
         style="display: none;"
      <?cs /if ?>
   >
      <td class="left_column">Database timeout<font color="#ff0000">*</font></td>
      <td class="inner_left" colspan="3">
         <?cs if:Channel.ReadOnlyMode ?>
            <?cs var:html_escape(dest.DatabaseTimeout) ?>
         <?cs else ?>
            <input class="configuration_smaller" name="DstDatabaseTimeout" id="DstDatabaseTimeoutInput"
               value="<?cs var:dest.DatabaseTimeout ?>">
            <script defer type="text/javascript">
               VALregisterIntegerValidationFunction
               (
                  'DstDatabaseTimeoutInput', 'RowDestTimeout', 'DstDatabaseTimeoutErrorMessageContainer',
                  function()
                  {
                     var TimeoutRow = document.getElementById('RowDestTimeout');
                     return WINgetStyle(TimeoutRow, 'display') != 'none';
                  },
                  showDestinationTab, 10, 25000
               );
            </script>
         <?cs /if ?>
         &nbsp;seconds
         <span id="DstDatabaseTimeoutErrorMessageContainer" class="validation_error_message_container"></span>
      </td>
   </tr>

<?cs /with ?>
