<?cs include:"doctype.cs" ?>
<html>  <?cs # vim: set syntax=html :?>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Dashboard</title>

   <!-- CSS -->
   <?cs include:"styles.cs" ?>
   <link rel="stylesheet" type="text/css" href="<?cs var:skin('dashboard.css') ?>" />
   <link rel="stylesheet" type="text/css" href="/js/help_popup/help_popup.css" />
   <link rel="stylesheet" type="text/css" href="jquery-ui/css/south-street/jquery-ui-1.7.2.custom.css" />
   
   <!-- JavaScript -->
   <script type="text/javascript"><!--
   UniqueInstanceId = '<?cs var:UniqueInstanceId ?>';
   DASHiconWarningImgSrc = '/<?cs var:skin('images/icon_warning.gif') ?>';
   DASHcurrentUser = '<?cs var:js_escape(CurrentUser) ?>';
   --></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/cookie/cookiev4.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("queryv4.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("refreshv4.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("sort.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/ajax/ajax.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("dashboard.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("class.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery142/jquery-1.4.2.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/help_popup/help_popup.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.core.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.draggable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.resizable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.dialog.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("from_channel.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("jquery-ui/js/jquery-ui-1.7.2.custom.min.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("table.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("dropdown.js") ?>"></script>
   <?cs include:"mini-login.cs" ?>
   
   <script type="text/javascript">
   var SplitterCookieKey = 'Iguana-Dashboard-Splitter-Pos';
   function saveSplitterPosition(FractionFromTop){
      COOKIEcreate( DASHcookieName(SplitterCookieKey), '' + FractionFromTop, 365);
   }

   function getSavedSplitterPosition(){
      var StrPos = COOKIEread( DASHcookieName(SplitterCookieKey));
      var IntPos = (StrPos ? Number(StrPos) : -1);
      return IntPos;
   }

   function adjustPanels(splitter_height, splitter_offset){
      var margin_from_splitter = 5;

      var doc_offset = $(window).height();
      var bottom_panel_top_pos = splitter_offset.top + splitter_height + margin_from_splitter;
      var top_panel_bottom_pos = doc_offset - (bottom_panel_top_pos - (2*margin_from_splitter) - splitter_height);

      $('#dashboard_top_panel').css('bottom', top_panel_bottom_pos);
      $('#dashboard_bottom_panel').css('top', bottom_panel_top_pos);
   }

   function onSplitterMove( Splitter, e, ui ) {
      adjustPanels($(Splitter).height(),ui.offset);
      saveSplitterPosition(getSplitterFraction(Splitter,ui.position.top));
   }

   function getSplitterFraction(Splitter,top_position){
      var splitter_fraction = top_position / $(Splitter).parent().height();
      return splitter_fraction;
   }

   function positionSplitter(Splitter, splitter_fraction){
      var container_height = $(Splitter).parent().height();
      var new_top = container_height * splitter_fraction;
      if (new_top > container_height){
         new_top = container_height;
      }
      else if (new_top < 0){
         new_top = 0;
      }
      $(Splitter).css('top',new_top);
   }

   //fix for jquery draggable to get cursor working in chrome
   document.onselectstart = function () { return false; };
   function initializeSplitter() {
      var Splitter = $('#dashboard_splitter');
      $(Splitter).draggable(
         {axis : 'y', 
          containment : 'parent', 
          drag: function(e,ui){ onSplitterMove(this,e,ui) },
	  stop: function(e,ui){ onSplitterMove(this,e,ui) },
	  cursor: 'move'
         }
      );
      var saved_fraction = getSavedSplitterPosition();
      if (saved_fraction >= 0){
         positionSplitter(Splitter,saved_fraction);
      }
      else{
         positionSplitter(Splitter,1); //position at bottom of container
      }
      adjustPanels($(Splitter).height(),$(Splitter).offset());
      
      $(window).resize( function() {  
      	 var Splitter = $('#dashboard_splitter');
	 var splitter_fraction = getSplitterFraction(Splitter, $(Splitter).offset().top - $(Splitter).parent().offset().top );
         positionSplitter(Splitter,splitter_fraction);
	 adjustPanels($(Splitter).height(),$(Splitter).offset());
      });
   }

   var SliderMouseInside = false;
   var SliderOpen = false;
   function initializeOptions(){
      $('body').mouseup(function(){ 
         if(!SliderMouseInside && SliderOpen) $('#divSlideOutTab').click();
      });
      function sliderHoverIn(){
         SliderMouseInside = true;
      }
      function sliderHoverOut(){
         SliderMouseInside = false;
      }
      $('#divSlideOutTab').click( 
         function(){ 
	 options = { left: 0 };
	 if (SliderOpen) options.left = -254;
	 $('#divSlideOut').animate( options, (SliderOpen ? 250 : 500) );
	 SliderOpen = !SliderOpen; 
         }
        )
        .hover(sliderHoverIn,sliderHoverOut);
      $('#divSlideOutContents').hover(sliderHoverIn,sliderHoverOut);
   }

   function initialize()
   {
      initializeSplitter();
      initializeOptions();
      DASHpreInitialize('<?cs var:javascript_escape(Time) ?>');
      DASHinitialize('<?cs var:javascript_escape(InitialJsonData) ?>');
   }
   </script>
</head>

<body class="tableft" onload="initialize();" style="width: 100%; height: 100%; margin: 0; padding: 0; overflow: hidden;">

<?cs set:Navigation.CurrentTab = "Dashboard" ?>

<?cs include:"header.cs" ?>

   <!-- see the js file for how this div is handled -->
   <div id="dashboard_warnings_panel" style="font-size: 11px; display: none; position: absolute; height: 300px; top: 100px; left: 25px; right: 25px; overflow: auto;">
      <?cs include:"dashboard_warnings.cs" ?>
   </div>

    <div id="divSlideOut" 
         style="border-spacing: -2px;	        
		border: 2px solid #757671;
                border-collapse: collapse;
   		z-index: 100;
		position: absolute; 
		top: 100px; 
		bottom: 5px; 
		left: -254px;
		width: 250px; 
		padding: 0; 
		margin: 0;">
       <div style="position: relative; 
                   height: 100%; 
		   width:100%; 
		   padding: 0; 
		   margin: 0;">
       <div id="divSlideOutContents"
            style="font-size: 1em; 
                   background: #E4E5E0; filter:alpha(opacity=85); 
		   opacity:0.85; 
		   position: absolute; 
		   width:100%; 
		   height: 100%; margin: 0; 
		   padding: 0;">
          <div style="font-size: 1em; 
	              padding: 2px 10px 2px 10px;
		      position: absolute:
		      height: 150px;
		      right: 0px;
		      left: 0px;
		      margin: 0;">
             <div style="width:100%; height: 100%">
	     <span class="dashboard_column_select_header">Channel Columns</span>
	     <div id="divChannelSlideOut" style="height: 85%; overflow-y: auto;"></div>
	     </div>
          </div>
          <div style="font-size: 1em; 
                      padding: 2px 10px 2px 10px; 
		      position: absolute;
		      top: 150px;
		      bottom: 5px;
		      right: 0px;
		      left: 0px;
                      margin: 0;">
	     <hr>
             <div style="width:100%; height: 100%;">
	     <span class="dashboard_column_select_header">Server Columns</span>
	     <div id="divServerSlideOut" style="height: 85%; overflow-y: auto;"></div>
	     </div>
          </div>
       </div>
       <div id="divSlideOutTab" 
            style="position: absolute; 
                   height: 165px; 
		   right: -22px;
		   width: 20px;
		   background-image: url('/images/view-options-tab.png');		   
		   background-repeat:no-repeat;
		   cursor: pointer;">
       </div>       
       </div>
    </div>

    <div id="dashboard_top_panel">

    <div id="dashboard_top_panel_container" style="position: absolute; top: 0px; bottom: 0px; left: 25px; right: 25px;" class="dashboard_backsplash">

    <div style="position: absolute; height: 30px; top: 0px; left: 0px; right: 0px;">
    <table class="dashboard_top">
      <tr>
         <td style="height: 25px; width: 40px;" id="cookie_crumb">
            Dashboard
         </td>
	 <td style="width: 400px; text-align:center; background-color: #e4e5e0;"><span id="spnUpdateStatus"></span></td>
         <td style="background-color: #e4e5e0; 
	    padding-top: 2px;
            padding-bottom: 1px;
            padding-right: 17px;
            color: #787a77;
            text-align: right;
            font-size: 9px;
            font-weight: normal;
            border-bottom: 1px solid #757671;"
         >
            <table class="search_field_container"><tr>
	       <td><span style="display: none; font-weight: bold; color: black;" id="spnSearchCountDisplay"/></td>
               <td style="padding-left:0px; padding-top:0px; padding-bottom:0px;">
                  <div class="search_field">
                     <img id="imgMagnifyingGlass" src="/<?cs var:skin("images/icon_search.gif") ?>"/>
                     <input id="inputChannelFilter" value=""
                        onkeyup="javascript:DASHonFilterStringChange(this.value);"
                        onmouseover="javascript:DASHshowSearchTooltip(this);"
                        onmouseout="javascript:DASHhideSearchTooltip(this);"
                        onmouseup="javascript:DASHhideSearchTooltip(this);"/>
                     <a onclick="javascript:DASHclearChannelFilter();">
                        <img id="imgClearFilterIcon" alt="" src="/<?cs var:skin("images/ex14.gif") ?>"/>
                     </a>
                  </div>
               </td>
               <td style="padding:0px;">
                  <a id="TextQuery_Icon" class="helpIcon" tabindex="100" title="More Information" target="_blank" href="#" onclick="return false;"
   rel="Use the Search field to display only the channels whose name or description matches what you type in the field.
			<p>In this field, you can specify multiple words to be matched, exclude words, or use regular expressions.</p>
			<p>For example, the search</p>
		       <p><strong>animal NOT (dog OR cat) -kitten /me+ow/</strong></p>
		       <p>matches all channel names or descriptions that contain <strong>animal</strong>, do not contain <strong>dog</strong>, <strong>cat</strong> or <strong>kitten</strong>,
			and contain <strong>m</strong> followed by one or more of <strong>e</strong> followed by <strong>ow</strong>
			(for example, <strong>meow</strong>, <strong>meeow</strong> and <strong>meeeow</strong>).</p>
                             <a href=&quot;http://www.interfaceware.com/manual/iguana4_dashboard_search_criteria.html&quot; target=&quot;_blank&quot;>Learn More About Specifying Search Criteria In A Dashboard Search</a></br>
			<p>For additional dashboard information:</p>
               <li>
               <a href='http://www.interfaceware.com/manual/iguana4_working_with_channels.html' target='_blank'>Working With Channels</a>
               </li>
               <li>
               <a href='http://www.interfaceware.com/manual/iguana4_viewing_and_editing_server.html' target='_blank'>Viewing and Editing Server Information</a>
               </li>">
                     <img src="<?cs var:skin("/images/help_icon.gif") ?>" border="0" />
                  </a>
               </td>
            </tr>
	    </table>
         </td>
      </tr>
   </table>
   </div>

   <div id="divDashboardTable_panel" style="position: absolute; bottom: 50px; top: 35px; left: 5px; right: 5px; padding: 0; margin: 0;">
        <div id="divDashboardTable" style="position: absolute; width: 100%; height: 100%;"></div>
   </div>

   <div style="position: absolute; bottom: 0px; height: 50px; left: 5px; right: 5px;">
         <table border=0 id="buttons" width="100%">
            <tr>
               <td align="left" width="25%">  
	                  <table style="border-spacing: 0px; border-collapse: collapse; padding: 0; margin: 0;">
                           <tr><td style="padding: 0px; margin: 0px;">
                           <select style="width:180px" id="bulkDropDown" name="bulkDropDown" onChange="DASHbulkDoAction(this);">
                           <option value="0">Channel Actions</option>
                           <option value="start">Start Channel(s)</option>
                           <option value="stop">Stop Channel(s)</option>
                           <option value="clearChannelErrors">Clear/Mark Channel Errors</option>
                           <option value="clearChannelQueues">Clear Channel Queue(s)</option>
                           </select>
                           </td></tr>
                           <tr><td style="padding: 0px; margin: 0px;">
                           <span id="bulkStatus"><?cs if:ClearChannelErrorsBusy!=0 ?>Busy Clearing Errors... <?cs /if ?></span>
                           </td></tr>  
                         </table>
              </td>
	      <td align="center">
	      <div style="margin-left: auto; margin-right: auto;" id="ChannelListPagingContainer"></div>
	      </td>
              <td width="25%" align="right" >
               <a id="hrefAddChannelButton"
                  href="add_channel.html" <?cs if:!CurrentUserCanAdmin ?>style="display:none;"<?cs /if ?>
                  onmousedown="this.firstChild.src='<?cs var:skin('images/button-addchannelv4_active.gif') ?>';"
                  onmouseover="this.firstChild.src='<?cs var:skin('images/button-addchannelv4_hover.gif') ?>';"
                  onmouseout="this.firstChild.src='<?cs var:skin('images/button-addchannelv4.gif') ?>';"
                  ><img src="<?cs var:skin('images/button-addchannelv4.gif') ?>"
                        width="192" style="border:none; padding: 0 0 0 0; margin: 5px 0 0 5px;"
               /></a> 
               <img id="AddChannelButton"
                     src="<?cs var:skin('images/button-addchannelv4_disable.gif') ?>"
                     width="192"
                     style="border:none; padding: 10px; <?cs if:CurrentUserCanAdmin ?>display:none;<?cs /if ?>"
                     onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to add a channel.', null, this);"
                     onMouseOut="TOOLtooltipClose();"
                     onmouseup="TOOLtooltipClose();"/>
              </td>
           </tr>
         </table>
      </div>
    </div>
</div>

<div id="dashboard_splitter_container">
   <div id="dashboard_splitter"></div>
</div>

<div id="dashboard_bottom_panel" class="dashboard_backsplash">
   <div id="divServerTablePanel">
      <div id="divServerTable"></div>
   </div>
</div>

</div>

<div id="bulk_confirm_dialog_form" title="Channel Action" style="display:none;">
   <div id="bulk_confirm_msg"></div>
   <span id="bulk_confirm_permissions_msg"/></span>

   <form id="clearQueuesForm">
   <p>Enter password to clear queues for the selected channels.</p>
   <p>Queues will only be cleared for channels that are not running.</p>
   <fieldset>
      <label for="ClearQueuesPassword">Password</label>
      <input type="password" name="ClearQueuesPassword" id="ClearQueuesPassword" value=""/>
   </fieldset>
   </form>
   <span id="bulk_confirm_error" style="width: 100%; color: red; font-size: 10px; text-align: center;"></span>
</div>

<div id="helpTooltipDiv" class="helpTooltip">
   <b id="helpTooltipTitle"></b>
   <em id="helpTooltipBody"></em>  
   <input type="hidden" name="helpTooltipId" id="helpTooltipId" value="0">
</div>

<div id='no_permissions_popup' style='width:450px;overflow:hidden;' title='Permission Error'><div id='no_permissions_msg'></div></div>
<div id='upgrade_log_file_popup' style='width:450px;overflow:hidden;' title='Iguana Log File Upgrade'><div id='upgrade_log_file_popup_msg'></div></div>

</body>
</html>
