<?cs include:"doctype.cs" ?>

<html>  <?cs # vim: set syntax=html :?>
<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; Users and Roles &gt; <?cs if:Role.Name ?>Edit<?cs else ?>Add<?cs /if ?> Role</title>
   <link rel="stylesheet" type="text/css" href="jquery-ui/css/south-street/jquery-ui-1.7.2.custom.css" />  
   <?cs include:"styles.cs" ?>
   <link rel="stylesheet" type="text/css" href="<?cs var:skin("transition.css") ?>" /> 
   <style type="text/css">
         
      a.button
      {  	  
         float:left;
      }

   </style>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery132/jquery-1.3.2.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.core.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.draggable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.resizable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.dialog.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/tooltip.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/templates/edit_group.js") ?>"></script> 
   <script type="text/javascript" src="<?cs var:iguana_version_js("/access_control.js") ?>"></script> 
   <script type="text/javascript"><!--

   var ChannelGroupNames = new Array(<?cs var:#ChannelGroupCount ?>);

   <?cs set:count = #0 ?> 
   <?cs each: group = ChannelGroup ?>
   ChannelGroupNames[<?cs var:count ?>] = "<?cs var:js_escape(group.Name) ?>";
   <?cs set:count = count + #1 ?>
   <?cs /each ?>

   --> </script>
</head>

<body class="tabright">

<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>

<div id="main">

   <div id="iguana">

      <div id="cookie_crumb">
         <a href="/advanced.html">Settings</a> &gt; <a href="/role_control.html">Roles & Users</a> &gt; <?cs if:Role.Name ?>Edit<?cs else ?>Add<?cs /if ?> Role
      </div>

      <div id="dashboard_body">

         <center>

            <form name="role_data" method="post" action="/role_control.html" onSubmit="return update_role();">
                 
               <div class="workarea">

                  <input id="current_user_can_admin" type="hidden" value="<?cs var:CurrentUserCanAdmin ?>" />
                  <input id="current_user" type="hidden" value="<?cs var:html_escape(CurrentUser) ?>" />

                  <h1>
                     <?cs if:Role.Name ?>
                     Edit Role
                     <?cs else ?>
                     Add Role  
                     <?cs /if ?>
                  </h1>
                 
                  <div class="border_green"></div>

                  <div id="result" class="<?cs if:ErrorMessage ?>error<?cs elif:StatusMessage ?>success<?cs else?>indeterminate<?cs /if ?>"> 

                     <div class="result_buttons_system">
                        <a id="result_close" ><img src="images\close_button.gif"/></a>
                     </div>    

                     <div id="result_title" class="<?cs if:ErrorMessage ?>error<?cs elif:StatusMessage ?>success<?cs /if ?>">

                        <?cs if:ErrorMessage ?>

                        Error
                        <?cs set:Content=ErrorMessage ?>

                        <?cs else ?>

                        Success
                        <?cs set:Content=StatusMessage ?>

                        <?cs /if ?>   

                     </div>

                     <div id="result_content">
                        <?cs var:html_escape(Content) ?>
                     </div>

                  </div>

                  <div id="group_info" > 
               
                     <h2>                 
                     Role Details
                     </h2>
               
                     <fieldset>

                        <ul>

                           <li class="generic_control">

                              <div class="label_text">
                              Name
                              </div> 

                              <?cs if:Role.Name ?>
                   
                              <div class="value_text">
                                 <?cs var:html_escape(Role.Name) ?>
                              </div>

                              <input type="hidden" id="role" name="role" value="<?cs var:html_escape(Role.Name) ?>" />
                              <input type="hidden" id="action" name="action" value="editRole" />
 
                              <?cs else ?>

                              <div class="field_text">
                                 <input class="text" id="role" name="role" />
                              </div>

                              <input type="hidden" id="action" name="action" value="createRole" />

                              <?cs /if ?>
                  
                           </li>

                           <li class="textarea_control">

                              <div class="label_text">
                              Description
                              </div> 

                              <div class="field_text">
                                 <textarea class="group_description" id="description" name="description"><?cs var:html_escape(Role.Description) ?></textarea>
                              </div>

                           </li>

                        </ul>

                     </fieldset>

                  </div>

                  <?cs if:CurrentUserCanAdmin ?>

                  <div id="permissions_border" class="border_grey" ></div>

                  <div id="permissions" >

                     <h2>
                     Channel Groups
                     </h2>

                     <div id="permissions_nonadmin">

                        <fieldset>
 
                           <ul>

                              <li class="permissions_control">

                                 <?cs if:Role.Name == "Administrators" ?>
                                 The Administrators role has full access to all features in Iguana.  This cannot be modified.
                                 <?cs else ?>
  
                                 <div id="role_channel_group_list" class="list" >

                                    <?cs if:ChannelGroupCount == 0 ?>
 
                                    There are no configured channel groups.

                                    <?cs else ?>

                                    <input id="channel_group_count" type="hidden" value="<?cs var:#ChannelGroupCount ?>" />

                                    <div class="permission_row_select_all"> 

                                       <div class="viewable" >

                                          <div id="group_drop_down_cell" <?cs if:ViewableChannelGroupCount == ChannelGroupCount ?>class="hidden_not_place_holder"<?cs /if ?>>
                                             <select id="group_drop_down">

                                                <option value="0">Add a channel group</option>

                                       <?cs each:item = ChannelGroup ?>
                                          <?cs if:!item.Viewable ?>

                                                <option value="<?cs var:item.ID ?>"><?cs var:item.Name ?></option>

                                          <?cs /if ?>
                                       <?cs /each ?> 
                              
                                             </select>

                                          </div>

                                       </div>  

                                       <div id="select_all" <?cs if:!ViewableChannelGroupCount ?>class="hidden_not_place_holder"<?cs /if ?> >

                                          <div id="select_all_reconfigure" class="reconfigurable" > 
                                             <a id="reconfigure_all"><em> All</em></a> | <a id="reconfigure_none"><em> None</em></a>
                                          </div>
 
                                          <div id="select_all_startstop" class="startstopenabled label" >
                                             <a id="startstop_all"><em> All</em></a> | <a id="startstop_none"><em> None</em></a> 
                                          </div>   

                                          <div id="select_all_export" class="exportenabled label" >
                                             <a id="exportlogs_all"><em> All</em></a> | <a id="exportlogs_none"><em> None</em></a> 
                                          </div> 

                                       </div> 

                                    </div>

                                    <ul>

                                       <?cs each:item = ChannelGroup ?>

                                       <li id="channel_group_<?cs var:item.ID ?>" class="channel_group_row dark_row <?cs if:!item.Viewable ?>hidden_not_place_holder<?cs /if ?>">

                                          <div class="permission_row" >

                                             <input class="group_id" type="hidden" value="<?cs var:item.ID ?>" />   

                                             <div class="viewable">

                                                <a class="label channel_group_toggle">
                                                   <input class="group_id" type="hidden" value="<?cs var:item.ID ?>" />
                                                   <img id="channel_group_details_<?cs var:item.ID ?>_toggle" src="/images/arrow-contracted.gif" />
                                                   <span id="channel_group_name_<?cs var:item.ID ?>" ><?cs var:html_escape(item.Name) ?></span>
                                                </a>

                                                <a class="channel_group_remove">
                                                   <input class="group_id" type="hidden" value="<?cs var:item.ID ?>" />
                                                   <input class="group_name" type="hidden" value="<?cs var:html_escape(item.Name) ?>" /> 
                                                   [remove]
                                                </a>

                                             </div>  
 
                                             <div class="reconfigurable label_checkbox" id="channel_group_reconfigure_<?cs var:item.ID ?>_cell" >
                                                <input type="checkbox" id="channel_group_reconfigure_<?cs var:item.ID ?>" name="channel_group_reconfigure_<?cs var:item.ID ?>" <?cs if:item.Reconfigurable ?>checked<?cs /if ?> class="checkbox" /> Edit
                                             </div>
 
                                             <div class="startstopenabled label_checkbox" id="channel_group_startstop_<?cs var:item.ID ?>_cell" >
                                                <input type="checkbox" id="channel_group_startstop_<?cs var:item.ID ?>" name="channel_group_startstop_<?cs var:item.ID ?>" <?cs if:item.StartStopEnabled ?>checked<?cs /if ?> class="checkbox" /> Start/Stop
                                             </div>  

                                             <div class="exportenabled label_checkbox" id="channel_group_export_<?cs var:item.ID ?>_cell" >
                                                <input type="checkbox" id="channel_group_export_<?cs var:item.ID ?>" name="channel_group_export_<?cs var:item.ID ?>" <?cs if:item.ExportLogEnabled ?>checked<?cs /if ?> class="checkbox" /> Export
                                             </div>  
    
                                          </div>

                                          <div id="channel_group_details_<?cs var:item.ID ?>" class="permissions_row_details hidden_not_place_holder" >

                                             <input class="group_id" type="hidden" value="<?cs var:item.ID ?>" />   

                                             <div style="padding-left:10px;" >

                                                <?cs if:item.ChannelCount == #0 ?>  

                                                There are no channels in this group.

                                                <?cs else ?>

                                                <ul>

                                                   <?cs each:item_channel = item.Channels ?> 

                                                   <li>
                                                      <?cs var:html_escape(item_channel.Name) ?>
                                                   </li>  

                                                   <?cs /each ?>  

                                                </ul>

                                                <?cs /if ?> 

                                             </div>                         
   
                                          </div>

                                       </li>

                                       <?cs /each ?>
                          
                                    </ul>
 
                                    <?cs /if ?>

                                 </div>

                                 <?cs /if ?>

                              </li>

                           </ul>

                           <?cs each:item = ChannelGroup ?>
                           <input id="<?cs var:item.ID ?>" name="<?cs var:item.ID ?>" class="channel_group_view_state" type="hidden" value="<?cs if:!item.Viewable ?>invisible<?cs else ?>visible<?cs /if ?>" />
                           <?cs /each ?> 
  
                           <div id="viewable_channel_group_none_blurb" class="effective_permissions_blurb">
                           There are no viewable channel groups for this role.  
                           </div> 

                        </fieldset>

                     </div>

                  </div>         
 
                  <?cs /if ?>                       

                  <div class="border_grey" ></div>

                  <div class="buttons">

                     <center>

                        <!-- For buttons with embedded image, it must wrap the within a table cell in order for the text to be aligned properly on IE7.
                             This can be removed once the style is fixed for IE. --> 

                        <table style="border:0px;padding:0px;margin:0px;display:inline;"><tr><td style="border:0px;padding:0px;margin:0px;">
                 
                           <?cs if:Role.Name ?>
    
                           <!-- The submit button is hidden, and a nicer looking button takes its place -->
                           <input id="apply_changes" class="hidden_submit" type="submit" value="Apply Changes">
                           <a class="button" id="save"><span><img src="../<?cs var:skin("images/icon_save.gif") ?>" /> &nbsp;Save Changes</span></a>

                           <?cs else ?>
                        
                           <!-- The submit button is hidden, and a nicer looking button takes its place -->
                           <input id="apply_changes" class="hidden_submit" type="submit" value="Add Role">
                           <a class="button" id="save"><span><img src="../<?cs var:skin("images/icon_save.gif") ?>" /> &nbsp;Add Role</span></a>
                     
                           <?cs /if ?>

                           </td>
                           <td style="border:0px;padding:0px;margin:0px;">

                              <a class="button_space button" href="/role_control.html"><span>Cancel</span></a>

                           </td></tr>

                        </table>

                     </center>
 
                  </div>   
 
               </div>

            </form>
                        
         </center>

      </div>
     
   </div>
   
</div>

<div id="side_panel">
   
   <div id="side_table">
      
      <div id="side_header">
      Page Help
      </div>

      <div id="side_body">

         <h4 class="side_title">Overview</h4>

         <?cs if:Role.Name ?>

         <p>
         On this page, you can change the permissions for the role.
         </p> 

         <?cs else ?>

         <p>
         Use this page to add a new role to this Iguana server.
         </p>

         <?cs /if ?>
	
	 <h4 class="side_title">Related Settings</h4>

         <a href="/email_status.html">Email Notification</a><br/>
         <a href="/channel_groupings_control.html">Channel Groups</a>
    
      </div>

      <div id="side_body">

         <h4 class="side_title">Help Links</h4>

         <ul class="help_link_icon">
         
            <?cs if:Role.Name ?>

            <li>
               <a href="http://www.interfaceware.com/manual/iguana4_assigning_user_to_group.html" target="_blank">Adding a User to a Role</a>
            </li>
            <li>
               <a href="http://www.interfaceware.com/manual/iguana4_user_group_permissions.html" target="_blank">Editing Role Permissions</a>
            </li>

            <?cs else ?>

            <li>
               <a href="http://www.interfaceware.com/manual/iguana4_creating_user_group.html" target="_blank">Creating a Role</a>
            </li>

            <?cs /if ?>

         </ul>

      </div>
   
   </div>

</div>

</body>

</html> 
