<?cs include:"doctype.cs" ?>
<?cs include:"email_notification_macros.cs" ?>

<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; Email Notification &gt; Validation</title>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery132/jquery-1.3.2.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.core.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.draggable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.resizable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.dialog.js") ?>"></script>
   <link rel="stylesheet" type="text/css" href="jquery-ui/css/south-street/jquery-ui-1.7.2.custom.css" />
   <?cs include:"styles.cs" ?>
</head>
<script type="text/javascript"> <!--

--></script>
<body class="tabright">

<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>


<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/advanced.html">Settings</a> &gt; <a href="/email_status.html">Email Notification</a> &gt; Validation
         </td>
      </tr>
      <tr>
         <td id="dashboard_body">
            <center>
            
            <?cs if:EmailNotSetup ?>
            <!-- EMAIL NOT SETUP -->
               
               <?cs call:email_not_setup_page_contents() ?>
            
            
            <?cs elif:EmailDisabled ?>
            <!-- EMAIL DISABLED -->
            
               <?cs call:email_disabled_page_contents("Status") ?>
            
            <?cs else ?>
            <!-- EMAIL SETUP -->
            
               <div class="tabs_and_contents">
               
                  <?cs call:email_navigation_tabs("Status", "return true;") ?>
            
                  <?cs if:ActionResult ?>
                  <p>
                     <b style="color: green"><?cs var:ActionResult ?></b>
                  </p>
                  <?cs elif:EmailSettingsValidated ?>
                  <p>
                     <b style="color: green;">Email settings are validated.</b>
                  </p>
                  <?cs /if ?>
                  
                  <?cs if:EmailSettingsValidated ?>
                  <p>
                     Iguana's email settings have been configured and validated.
                  </p>
                  <?cs else ?>
                  <p>
                     <b style="color: red;">Warning: email notification has not been validated.</b>
                  </p>
                  <p>
                     To ensure that email notification is working properly, click <b>Send Validation Email</b> to send a validation email message. 
                  </p>
                  <?cs /if ?>
                  
                  <table id="buttons"><tr><td>
                     <a class="button" href="/send_validation_email.html"><span>Send Validation Email</span></a>
                  </td><td>
                     <?cs if:!EmailSettingsValidated ?>
                        <a class="button" href="/email_status.html?Action=ignore_validation_warning"><span>Ignore Warning</span></a>
                     <?cs else ?>
                        <a class="button" href="/email_status.html"><span>Back to Email Notification</span></a>
                     <?cs /if ?>
                  </td></tr></table>
               
               </div>
               
            <?cs /if ?>
            
            </center>
         </td>
      </tr>
   </table>

</div>

<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
            <p>
               From this page, you can send a validation email message to confirm that your email notification settings are correct.
            </p>
            <?cs call:link_to_users_and_groups() ?>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
               <li>
               <a href="http://www.interfaceware.com/manual/iguana4_validating_email_notification.html" target="_blank">Validating Email Notification</a>
               </li>
            </ul>
         </td>
      </tr>
   </table>
</div>

</body>

</html>
