<?cs include:"doctype.cs" ?>
<?cs include:"access_control_macros.cs" ?>
<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; Users and Groups</title>
   <?cs include:"styles.cs" ?>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery132/jquery-1.3.2.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.core.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.draggable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.resizable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.dialog.js") ?>"></script> 
   <link rel="stylesheet" type="text/css" href="jquery-ui/css/south-street/jquery-ui-1.7.2.custom.css" />  
</head>

<script type="text/javascript"> <!--

function remove_group(Group)
{
   if( confirm('Remove group "' + Group + '"?') )
   {
      document.remove_group.group.value = Group;
      document.remove_group.submit();
   }
}

--> </script>

<body class="tabright">

      <?cs set:Navigation.CurrentTab = "Settings" ?>
      <?cs include:"header.cs" ?>

<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/advanced.html">Settings</a> &gt; Users and Groups
         </td>
      </tr>

      <tr>
         <td id="dashboard_body">
            <center>

	       <div class="tabs_and_contents">

	       <?cs call:users_groups_navigation_tabs("Groups", "return true;") ?>
             
               
               <?cs if:ErrorMessage ?>
                  <h3><font color="red"><?cs var:html_escape(ErrorMessage) ?></font></h3>
               <?cs /if ?>
               
               <?cs if:StatusMessage ?>
                  <h3><font color="green"><?cs var:html_escape(StatusMessage) ?></font></h3>
               <?cs /if ?>
              
               <form name="remove_group" method="get" action="groups_view.html">
                  <input type="hidden" name="action" value="removeGroup" />
                  <input type="hidden" name="group" />
               </form>
          <p>
          </p>
               
                  <table id="groups" class="configuration">
                     <tr>
                        <th colspan="3">GROUPS</th>
                     </tr>
                     <?cs if:CountOfGroup == 0 ?>
                     <tr>
                        <td colspan="3" style="color: gray; text-align: center;">&lt;None&gt;</th>
                     </tr>
                     <?cs /if ?>
                     <?cs each: group = Groups ?>
                        <tr>
                           <td class="left_column"><?cs var:html_escape(group.Name) ?></td>
                           <td>
                              <?cs if:CurrentUserCanAdmin ?>
                                 <a class="button" href="/editGroup?group=<?cs var:url_escape(group.Name) ?>"><span>
                                    <img src="../<?cs var:skin("images/icon_edit.gif") ?>" /> &nbsp;Edit
                                 </span></a>
                              <?cs else ?>
                                 <div class="button_disable"
                                    onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);"
                                    onMouseOut="TOOLtooltipClose();"
                                    onmouseup="TOOLtooltipClose();" >
                                    <span>
                                       <img src="../<?cs var:skin("images/icon_edit_disable.gif") ?>" /> &nbsp;Edit
                                    </span>
                                 </div>
                              <?cs /if ?>
                           </td>
                           <td>
                              <?cs if:CurrentUserCanAdmin ?>
                                 <a class="button" href="javascript:remove_group('<?cs var:html_escape(js_escape(group.Name)) ?>')"><span>
                                    <img src="../<?cs var:skin("images/icon_remove.gif") ?>" /> &nbsp;Remove
                                 </span></a>
                              <?cs else ?>
                                 <div class="button_disable"
                                    onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to remove a group.', null, this);"
                                    onMouseOut="TOOLtooltipClose();"
                                    onmouseup="TOOLtooltipClose();" >
                                    <span>
                                       <img src="../<?cs var:skin("images/icon_remove_disable.gif") ?>" /> &nbsp;Remove
                                    </span>
                                 </div>
                              <?cs /if ?>
                           </td>
                        </tr>
                     <?cs /each ?>
                  </table>
                  
                           <table id="buttons"><tr><td>
                              <?cs if:CurrentUserCanAdmin ?>
                                 <a class="button" href="/editGroup" onclick="this.blur();"><span>
                                    <img src="../<?cs var:skin("images/icon_add.gif") ?>" /> &nbsp;Add Group
                                 </span></a>
                              <?cs else ?>
                                 <div class="button_disable"
                                    onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to add a group.', null, this);"
                                    onMouseOut="TOOLtooltipClose();"
                                    onmouseup="TOOLtooltipClose();" >
                                    <span>
                                       <img src="../<?cs var:skin("images/icon_add_disable.gif") ?>" /> &nbsp;Add Group
                                    </span>
                                 </div>
                              <?cs /if ?>
                           </td></tr></table>

           <br />
               
               </div>
      
               
            </center>
         </td>
      </tr>

   </table>

</div>
      <div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
            <?cs if:CurrentUserCanAdmin ?>
               <p>
                  Users and groups can be used to control who has access and configuration
                  rights to Iguana.   They are also used to define
                  email addresses for <a href="email_rules_view.html">email notification rules</a>.
               </p>
            <?cs else ?>
               <p>
                  From this page, you can edit your own user information.
               </p>
               <p>
                  You must have administrator permissions to view and edit other users and user groups.
               </p>
            <?cs /if ?>
		    <h4 class="side_title">Related Settings</h4>
            <a href="/email_status.html">Email Notification</a><br/>
			<a href="/channel_groupings_control.html">Channel Groups</a>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
               <li>
               <a href="http://www.interfaceware.com/manual/iguana4_config_users_groups.html" target="_blank">Users &amp; Groups</a>
               </li>
            </ul>
         </td>
      </tr>
   </table>
   </div>
</body>

</html>
</body>
</html>
