<?cs include:"doctype.cs" ?>

<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; Log Settings </title>
   <?cs include:"styles.cs" ?>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/ajax/ajax.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
   <style type="text/css">
   .subtle
   {
      text-align: left;
      color: #808080;
   }
   </style>
   <script type="text/javascript">
   
      function purgeNow()
      {
         document.log_settings_view.action.value = "purge_now";
         document.log_settings_view.submit();
      }
     
      function setPurgeButton(PurgeInProgress)
      {
         <?cs if:CurrentUserCanAdmin ?>
         PurgeEnabledHtml = '<a class="button" style="text-align: center;" href="log_purge_confirm"><span style="text-align: center;">Purge Now</span></a>';
         PurgeDisabledHtml = '<div class="button_disable" style="float:right"\
                        onMouseOver="TOOLtooltipLink(\'Another log purge is currently in progress.\', null, this);"\
                        onMouseOut="TOOLtooltipClose();"\
                        onmouseup="TOOLtooltipClose();" >\
                        <span>Purge Now</span></div>';
         NewHtml = (PurgeInProgress ? PurgeDisabledHtml : PurgeEnabledHtml);
         if (NewHtml == PurgeEnabledHtml)
         {
            TOOLtooltipClose();
         } 
         document.getElementById('btnPurgeNow').innerHTML = NewHtml;
         <?cs /if ?>
      }

      function onLoad()
      {
         setPurgeButton(<?cs if:LogPurgeInProgress=='1' ?>true<?cs else ?>false<?cs /if ?>);
         checkLogPurge();
      }

      function checkLogPurge()
      {
         AJAXpost('/log_purge_progress', 'AutomaticRequest=1',
                function(Data, ContentType){
                   Result = eval("(" + Data + ")");
                   if( ContentType == 'text/javascript' && Result )
                   {
	              setPurgeButton(Result.LogPurgeInProgress);
                   }
                   else
                   {
                      alert(Data.replace(/^ERROR\s*/, ''));
                   }
                   setTimeout("checkLogPurge()",1000);
                },
                function(Error){
                   document.getElementById('ajax_error_label').innerHTML = Error.Description;
                }
         );
      }      
   </script>
</head>

<body class="tabright" onLoad="onLoad()">

<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>


<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/advanced.html">Settings</a> &gt; Log Settings 
         </td>
      </tr>
      
      <!-- Log settings table -->
      <td>
            <center>
               <font color="red"><div id="ajax_error_label"></div></font>
               <?cs if:SettingsChanged == "true" ?>
                  <p>
		               <font color="green"><b>Log settings have been changed.</b></font>
		            </p>
               <?cs /if ?>
               <?cs if:SettingsChanged == "false" ?>
                  <p>
                     <font color="red"><b>No changes to log settings.</b></font>
                  </p>
               <?cs /if ?>
             </center>
         </td> 
      </tr>
      <tr>
         <td id="log_settings">
            <center>
               <form name="log_settings_view" method="post" action="/log_settings_view.html">
               <input type="hidden" name="action" value="">
               <table class="configuration">
                  <tr>
                     <th colspan="2">Log Settings</th>
                  </tr>
                  <tr>
                     <td class="left_column">Log Directory</td>
                     <td class="inner_left">
                        <table class="inner">
                           <tr><td class="inner_left" ><?cs var:html_escape(LogDirectory) ?> </td></tr>
                        </table>
                     </td>

		            </tr>
                  <tr>
                     <td class="left_column">Maximum Log Age</td>
                     <td>
                        <?cs var:html_escape(LogPurgeMaxAge) ?> day<?cs if:LogPurgeMaxAge != 1 ?>s<?cs /if ?>
                        <?cs if: LogPurgeMaxAge > RecommendedMaxMaxAge ?>
                           <span class="subtle">
                              (keeping logs longer than <?cs var:#RecommendedMaxMaxAge ?> days has some <a href="http://www.interfaceware.com/manual/log_performance_considerations.html" target="_blank">additional overhead</a>)</span>
                        <?cs /if ?>
                     </td>
                  </tr>
                  <tr>
                     <td class="left_column">Log Purge Time</td>
                     <td class="inner_left">
                        <table class="inner">
                           <tr><td class="inner_left" ><?cs var:html_escape(LogPurgeHour) ?>:<?cs var:html_escape(LogPurgeMinute) ?><?cs if: LogPurgeTimeMeridien == "1" ?> pm <?cs else?> am <?cs /if?></td>
                              
                                 <td rowspan=2 align="center">
				 <?cs if CurrentUserCanAdmin ?>
  	                          <div id="btnPurgeNow"><!-- filled by javascript --></div>
				 <?cs else ?>
   		                 <div class="button_disable" style="float:right"
				 onMouseOver="TOOLtooltipLink('You do not have neccessary permissions to purge logs.', null, this);"
                                 onMouseOut="TOOLtooltipClose();"
                                 onmouseup="TOOLtooltipClose();" >
 	                         <span>Purge Now</span></div>
				 <?cs /if ?>
		                 </td>
                           </tr>
                           <tr><td><span class="subtle">Iguana will purge logs every day at this scheduled time.</span></td></tr>
                           
                        </table>
                        
                     </td>
                  </tr>
                  <tr>
                     <td class="left_column" valign="top">Synchronous Writes</td>
                     <td style="width:400px"><?cs if:LogSynchronousWrites=='1' ?>Yes<?cs else ?>No<?cs /if ?></td>
                  </tr>
		  <?cs if:!FtsInAllFiles ?>
		  <tr>
                     <td class="left_column" valign="top"> Background Text Indexing:</td>
                     <td style="width:400px"><?cs if:BackgroundTextIndexing=='1' ?>Yes<?cs else ?>No<?cs /if ?></td>		  
		  </tr>
		  <?cs /if ?>
               </table>
               </form>
               <!-- Change log settings button, should only be accessible if UserCanAdmin -->
               
		         <table>
		            <tr><td align="center">
                     <?cs if:CurrentUserCanAdmin ?>
                        <a class="button" href="/log_purge_settings.html" onclick="this.blur();"><span><img src="../<?cs var:skin("images/icon_edit.gif") ?>" /> &nbsp;Edit</span></a>
                     <?cs else ?>
                        <div class="button_disable" id="DisabledEditButton2" onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);" onMouseOut="TOOLtooltipClose();" onmouseup="TOOLtooltipClose();" ><span><img src="../<?cs var:skin("images/icon_edit_disable.gif") ?>"/> &nbsp;Edit</span></div>
                     <?cs /if ?>
		            </td></tr>
		         </table>
		
                  <p/><p/>
            </center>
		   </td>
	   </tr>
   </table>

</div>
<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
	     <p>
	 This page displays the logging configuration information.
	 </p> 
   <?cs if:CurrentUserCanAdmin ?>
	<p>Clicking on <b>Purge Now</b> will purge the logs with the current log purge settings.</p>
   <?cs /if ?>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Log Usage</h4>
	    <p>
            For detailed information of current log usage and trends, see
            <?cs # DO_NOT_RELEASE: Make this an external link. (MANUAL_TODO) ?>
            <a href="log_usage_statistics">Logs&nbsp;&gt;&nbsp;Log&nbsp;Usage</a>.</p>
         </td>
      </tr>

      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
            	<li>
            	<a href="http://www.interfaceware.com/manual/iguana4_config_logging.html" target="_blank">Logging</a>
            	</li>
            </ul>
         </td>
      </tr>
      
   </table>
</div>
</body>

</html>
