<?cs include:"doctype.cs" ?>

<?cs # vim: set syntax=html :?>

<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; Web Server</title>
   <?cs include:"styles.cs" ?>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/ajax/ajax.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery132/jquery-1.3.2.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.core.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.draggable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.resizable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.dialog.js") ?>"></script> 
   <link rel="stylesheet" type="text/css" href="jquery-ui/css/south-street/jquery-ui-1.7.2.custom.css" />  
   <?cs if:RestartLink ?>
<script type="text/javascript"> 

CountDown = 5;

function WebConfig_displayCountDown()
{
   var divRefreshStatus = document.getElementById('divRefreshStatus');
   Message = "The page will reload in " + CountDown + " seconds, or ";
   divRefreshStatus.innerHTML = Message;
}

function WebConfigView_onTimer()
{
   if(!(CountDown > 0))
   {
      return;
   }

   CountDown--;

   WebConfig_displayCountDown();

   if(CountDown <= 0)
   {
      window.location = '<?cs var:RestartLink ?>';
      return;
   }
   setTimeout('WebConfigView_onTimer()', 1000);
}

function ManageRestartTimer()
{
	AJAXpost('/restart', '' , function() {}, function() {});
	setTimeout('WebConfigView_onTimer()', 1000);
}



 </script>   
   <?cs /if ?>

<script type="text/javascript"> <!--
function submitRestartForm()
{
   Form = document.getElementById('RestartForm');
   Form.submit();
}

function showPopup(Target, Title)
{
   window.open(Target, Title, 'resizable, scrollbars, dependent');
   return false;
}

--></script>

</head>

<?cs def:showError(Value) ?>

<?cs if:Value ?>
<br><span style="color:red;" id="<?cs name:Value ?>"><?cs var:html_escape(Value) ?></span>
<?cs else ?>
<span id="<?cs name:Value ?>"></span>
<?cs /if ?>
<?cs /def ?>

<body class="tabright"<?cs if:RestartLink ?> onload="WebConfig_displayCountDown();ManageRestartTimer();"<?cs /if ?>>

<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>


<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/advanced.html">Settings</a> &gt; Web Server
         </td>
      </tr>

      <tr>
         <td id="dashboard_body">
            <center>
               <?cs if:ErrorMessage && !RestartLink ?>
                  <h3><font color="red" id="test.ErrorMessage"><?cs var:html_escape(ErrorMessage) ?></font></h3>
	       <?cs else ?>
	          <span id="test.ErrorMessage"></span>
               <?cs /if ?>
               
               <?cs if:StatusMessage  ?>
                  <h3><font color="green" id="test.StatusMessage"><?cs var:html_escape(StatusMessage) ?></font></h3>
               <?cs else ?>
	       	  <span id="test.StatusMessage"></span>
	       <?cs /if ?>

		<?cs if:RestartLink ?>
                <span id="divRefreshStatus"></span> <a href="<?cs var:html_escape(RestartLink) ?>">Continue</a></p>
		<p></p>
      <?cs /if ?>

         <table class="configuration" border="1" id="test.webserver">
         <tr class="header">
            <th colspan="2">Web Server Settings</th>
         </tr>
         <tr>
            <td class="left_column">Server Name</td>
            <td>
               <?cs if: !ServerLabelEdit ?>
                  <i>Unnamed</i>
               <?cs /if ?>
               <span id="test.ServerLabel"><?cs var:html_escape(ServerLabelEdit) ?></span>
	       <?cs if:ServerLabelEdit != environment_expand(ServerLabelEdit) ?>
                  <?cs if:ServerLabelEdit != "" ?>
                     <div class="path_preview">Preview: "<?cs var:html_escape(environment_expand(ServerLabelEdit)) ?>"</div>
                  <?cs /if ?>
               <?cs /if ?>
            </td>
         </tr>
         <tr>
            <td class="left_column">
               Allowable Login Failures
            <td>
               <?cs var:#LoginFailureLimit ?>
               <?cs if:#LoginFailurePeriod == 1 ?> each minute
               <?cs else ?> every <?cs var:#LoginFailurePeriod ?> minutes
               <?cs /if ?>
         </tr>
         <tr>
           <td class="left_column">Session Timeout<br><span style="font-weight:normal;">(in minutes)</span></td>
           <td><span id="test.SessionTimeout"><?cs var:html_escape(SessionTimeout) ?></span>
	   <?cs call:showError(SessionTimeout_ErrorString) ?>
	   </td>
         </tr>
         <tr>
           <td class="left_column">Web Server Port</td>
           <td><span id="test.WebPort"><?cs var:html_escape(WebPort) ?></span>
	   <?cs call:showError(WebPort_ErrorString) ?></td>
         </tr>
         <tr>
           <td class="left_column">Use HTTPS</td>
           <td>
              <?cs if:UsingHttps=="true" ?>Yes<?cs else ?>No<?cs /if ?>
         
          <?cs if:RestartLink ?>
          <?cs
            # not showing startup errors while restarting - it''s confusing,
          ?>
          <?cs else ?>

          <?cs if:HttpsState ?>
            <br>Startup Status: <?cs var:html_escape(HttpsState) ?>
          <?cs /if ?>
	       <?cs if:HttpsErrorMessage != "" ?>
	       	   <br><font color="red" id="test.HttpsErrorMessage"><?cs var:html_escape(HttpsErrorMessage) ?></font>
	       <?cs /if ?>
         <?cs call:showError(UsingHttps_ErrorString) ?>
         <?cs /if ?>
	   </td>
         </tr>

         <?cs if:UsingHttps=="true" ?>
         <tr>
            <td class="left_column">Certificate File</td>
            <td>
                  <span id="test.CertificateFile"><?cs var:html_escape(CertificateFile) ?></span>
	    <?cs call:showError(CertificateFile_ErrorString) ?>
               <?cs if:CertificateFile_Link ?>
                  <br><a href="<?cs var:html_escape(CertificateFile_Link) ?>">view certificate</a>
               <?cs /if ?>
            </td>
         </tr>

         <tr>
           <td class="left_column">Private Key File</td>
           <td>
                  <span id="test.PrivateKeyFile"><?cs var:html_escape(PrivateKeyFile) ?></span>
	    <?cs call:showError(PrivateKeyFile_ErrorString) ?>
            </td>
         </tr>

         <?cs if:LoadCheck_ErrorString ?>
         <?cs
            # this row only appears when there''s a problem, 
            # so that we don''t have to explain what it is about otherwise
         ?>
         <tr id="RowLoadCheck">
            <td class="left_column">Load check</td>
            <td>
               <span style="color:red;">FAILED</span>
               <?cs call:showError(LoadCheck_ErrorString) ?>
            </td>
         </tr>
         <?cs /if ?>

         <?cs /if ?>

         </table>

	  <p>
<?cs if:!RestartLink ?> <!-- not restarting -->   
      <form action="web_settings_view.html" method="post" id="RestartForm" name="RestartForm">
         <input type="hidden" name="Restart" value="yep">
      </form>
      <table id="buttons"><tr><td>
      <!-- edit link -->
      <?cs if:CanEdit ?>
         <a class="button" href="/web_settings.html" onclick="this.blur();"><span><img src="../<?cs var:skin("images/icon_edit.gif") ?>" /> &nbsp;Edit</span></a>
      <?cs else ?>
         <div class="button_disable" id="DisabledEditButton" onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);" onMouseOut="TOOLtooltipClose();" onmouseup="TOOLtooltipClose();" ><span><img src="../<?cs var:skin("images/icon_edit_disable.gif") ?>"/> &nbsp;Edit</span></div>
      <?cs /if ?>
      </td><td>
      <!-- restart button -->
      <?cs if:CanEdit ?>
         <a class="button" href="javascript:submitRestartForm();" onclick="this.blur();"><span>Restart Web Server</span></a>
      <?cs else ?>
         <div class="button_disable" id="DisabledRestartButton" onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to restart the web server.', null, this);" onMouseOut="TOOLtooltipClose();" onmouseup="TOOLtooltipClose();" ><span>Restart Web Server</span></div>
      <?cs /if ?>
      <!-- IE hack to stop button from splitting up -->
      <!-- /restart button -->
      </td></tr></table>   
<?cs /if ?>
</p>

      <!-- end display area -->
            </center>
         </td>
      </tr>

   </table>

</div>
<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
	     <p>
	 On this page, you can view the web interface configuration for Iguana.
	 </p> 
   <?cs if:CanEdit ?>
	<p>Click <b>Change Settings</b> to change the settings on this page, or <b>Restart Web Server</b> to restart the Iguana server.</p>
   <?cs else ?>
      <p>You must be logged in as an administrator to edit the settings on this page.</p>
   <?cs /if ?>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
            	<li>
            	<a href="http://www.interfaceware.com/manual/iguana4_config_webserver.html" target="_blank">Web Server Configuration</a>
            	</li>
            </ul>
         </td>
      </tr>
   </table>
</div>
</body>

</html>

